<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class AdminMain extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("admin_main.tpl");
  }

  function Action($action)
  {
    @set_time_limit(0);

    $res=false;
    switch($action)
	{ case "setdomain": $res=$this->SetDomain(); break;
	  case "setlang": $res=$this->SetLang(); break;
	  case "setexpert": $res=$this->SetExpert(); break;
	  case "newdomain": $res=$this->AddDomain(); break;
	}
	if($res)
	A::goUrl("admin.php");
  }

  function SetDomain()
  {
	if(isset($_REQUEST['domain']) && A::$DB->existsRow("SELECT id FROM _domains WHERE name=?",$_REQUEST['domain']))
	{ A_Session::set("A_DOMAIN",$_REQUEST['domain']);
	  A_Session::set("A_LANG","");
	  return true;
	}
	else
	return false;
  }

  function SetLang()
  {
	if(isset($_REQUEST['lang']) && A::$DB->existsRow("SELECT id FROM ".DOMAIN."_languages WHERE name=?",$_REQUEST['lang']))
	{ A_Session::set("A_LANG",$_REQUEST['lang']);
	  return true;
	}
	else
	return false;
  }

  function SetExpert()
  {
	A::$DB->_Update("_auth",array('expert'=>!empty($_REQUEST['expert'])?'Y':'N'),"id=".A::$AUTH->id);
	if(A::$DB->cache)
	A::$DB->cache->resetTable('_auth');
    if(!empty($_GET['mode']) && in_array($_GET['mode'],array('system','site','files')))
    A::goUrl("admin.php");
	else
	A::goPrevUrl();
  }

  function AddDomain()
  {
	$_REQUEST['name']=substr(strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",$_REQUEST['name'])),0,30);
	$_REQUEST['domain']=preg_replace("/^http\:\/\//i","",trim($_REQUEST['domain']));
	$_REQUEST['domain']=preg_replace("/^www\./i","",$_REQUEST['domain']);
	$_REQUEST['domain']=mb_strtolower(preg_replace("/[^a-zA-Zа-яА-Я0-9._-]+/iu","",$_REQUEST['domain']));
	$_REQUEST['caption']=trim(strip_tags($_REQUEST['caption']));
	$_REQUEST['date']=time();

	$ignore=array('admin','tmp');

	if(empty($_REQUEST['name']) || in_array($_REQUEST['name'],$ignore) || A::$DB->existsRow("SELECT * FROM _domains WHERE name=?",$_REQUEST['name']))
	{ $this->errors['doubleid']=true;
	  return false;
	}
	if(empty($_REQUEST['domain']) || A::$DB->existsRow("SELECT * FROM _domains WHERE domain=?",$_REQUEST['domain']))
	{ $this->errors['doubledomain']=true;
	  return false;
	}

	$dataset = new A_DataSet("_domains");
	$dataset->fields=array("date","name","domain","caption");
	if($dataset->Insert())
	{ if($sql=@file_get_contents("system/sql-xml/domain_create.sql"))
      { $sql=str_replace("{domain}",$_REQUEST['name'],$sql);
        A::$DB->execSQL($sql,$_REQUEST['name']);
	  }

	  A::$LANG='ru';

	  if(!file_exists("templates/".$_REQUEST['name']))
	  { mk_dir("files/".$_REQUEST['name']);
		mk_dir("files/".$_REQUEST['name']."/reg_images");
		mk_dir("files/".$_REQUEST['name']."/reg_files");
		mk_dir("files/".$_REQUEST['name']."/image");
	    mk_dir("templates/".$_REQUEST['name']);
	    mk_dir("templates/".$_REQUEST['name']."/blocks");
		mk_dir("templates/".$_REQUEST['name']."/frames");
		mk_dir("templates/".$_REQUEST['name']."/mails");
		mk_dir("templates/".$_REQUEST['name']."/others");
  	    mk_dir("templates_c/".$_REQUEST['name']);
		mk_dir("templates_c/".$_REQUEST['name']."/blocks");
		mk_dir("templates_c/".$_REQUEST['name']."/frames");
		mk_dir("templates_c/".$_REQUEST['name']."/mails");
		mk_dir("templates_c/".$_REQUEST['name']."/others");
		mk_dir("cache/images/".$_REQUEST['name']);
	  }

      A_Session::set('A_DOMAIN',A::$DOMAIN=$_REQUEST['name']);

	  require_once("admin/site_import.php");

	  if(!empty($_FILES['configarch']['tmp_name']) && is_file($_FILES['configarch']['tmp_name']))
	  { $_REQUEST['importmode']=3;
	    SiteImport::Import($_REQUEST['name']);
	  }
	  else
	  { $_REQUEST['importmode']=2;
	    $_REQUEST['importpath']="templates/default.tar.gz";
	    SiteImport::Import($_REQUEST['name']);

	    if(!empty($_REQUEST['caption']))
		{ A::$DB->Update($_REQUEST['name']."_options",array('value'=>$_REQUEST['caption']),"item='' AND var='sitename_ru'");
          A::$DB->Update($_REQUEST['name']."_options",array('value'=>$_REQUEST['caption']),"item='' AND var='sitetitle_ru'");
          A::$DB->Update($_REQUEST['name']."_options",array('value'=>'no-reply@'.$_REQUEST['domain']),"item='' AND var='mailsfrom'");
        }

        if(isset($_REQUEST['torep']))
	    A::goUrl("admin.php?mode=rep&item=sites");
	  }

	  return true;
	}
	return false;
  }

  function access_domain($domain)
  {
    return count(A::$AUTH->data['access'])==0 || isset(A::$AUTH->data['access'][$domain]);
  }

  function createData()
  {
    $extensions=A::$DB->getOne("SELECT COUNT(*) FROM _extensions");
    if(empty($extensions))
    { require_once("admin/system_extensions.php");
	  SystemExtensions::Update();
    }

	if(DOMAIN=="")
	{ $form=array();
	  $form['domain']=HOSTNAME;
	  $form['name']=substr(translit(preg_replace("/[^a-zа-я0-9]+/iu","",mb_strtolower($form['domain']))),0,30);
	  $this->Assign("form",$form);
	  return;
	}

	$main=array('sections'=>array(),'structures'=>array());

    A::$DB->query("SELECT * FROM ".DOMAIN."_sections WHERE icon='Y' AND (lang='".A::$LANG."' OR lang='all') ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $item=$section=DOMAIN."_".$row['lang']."_".$row['name'];
	  if(A::$AUTH->isAdmin() || (isset(A::$AUTH->data['access'][DOMAIN]) && in_array($item,A::$AUTH->data['access'][DOMAIN])))
	  { $main['sections'][]=array("id"=>$row['id'],"item"=>$item,"name"=>$row['caption'],"ico"=>"/modules/".$row['module']."/ico.gif");
	    $file="modules/{$row['module']}/admin/statistic.php";
	    if(file_exists($file))
	    { require_once($file);
	      $class="{$row['module']}_Statistic";
		  $obj = new $class($section,$row['module']);
		  foreach($main['sections'] as $i=>$mitem)
	      if($mitem['item']==$item)
	      $main['sections'][$i]['stat']=str_replace("\"","'",$obj->getContent());
	    }
	  }
	}
	A::$DB->free();

    A::$DB->query("SELECT * FROM ".DOMAIN."_structures WHERE icon='Y' ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $item=$structure=DOMAIN."_structure_".$row['name'];
	  if(A::$AUTH->isAdmin() || in_array($structure,A::$AUTH->data['access'][DOMAIN]))
	  { $main['structures'][]=array("id"=>$row['id'],"item"=>$item,"name"=>$row['caption'],"ico"=>"/plugins/".$row['plugin']."/ico.gif");
	    $file="plugins/{$row['plugin']}/admin/statistic.php";
		if(file_exists($file))
	    { require_once($file);
		  $class="{$row['plugin']}_Statistic";
	      $obj = new $class($structure,$row['plugin']);
		  foreach($main['structures'] as $i=>$mitem)
	      if($mitem['item']==$item)
	      $main['structures'][$i]['stat']=str_replace("\"","'",$obj->getContent());
	    }
	  }
	}
	A::$DB->free();
	$this->Assign("main",$main);

	if(A::$AUTH->isAdmin())
	{ $blocks=array();
	  A::$DB->query("SELECT * FROM ".DOMAIN."_blocks WHERE icon='Y' AND (lang='".A::$LANG."' OR lang='all') ORDER BY sort");
	  while($row=A::$DB->fetchRow())
	  { if(file_exists("blocks/".$row['block']."/ico.gif"))
	    $ico="/blocks/".$row['block']."/ico.gif";
	    else
	    $ico="/templates/admin/images/icons/blocks.gif";
	    $link="admin.php?mode=site&item=blocks&id=".$row['id'];
	    $blocks[]=array('id'=>$row['id'],'ico'=>$ico,'link'=>$link,'caption'=>$row['caption']);
	  }
	  A::$DB->free();
	  $this->Assign("blocks",$blocks);
	}

	$domains=array();
	A::$DB->query("SELECT * FROM _domains ORDER BY domain");
	while($row=A::$DB->fetchRow())
	if($this->access_domain($row['name']))
	{ $row['selected']=$row['name']==DOMAIN;
	  $domains[]=$row;
	}

	if(count($domains)==1)
	{ if($domains[0]['selected'])
	  $domains=array();
	  else
	  { A_Session::set("A_DOMAIN",$domains[0]['name']);
	    A_Session::set("A_LANG","");
	    A::goUrl("/admin.php");
	  }
	}
	$this->Assign("domains",$domains);

	$languages=array();
	foreach(A::$LANGUAGES as $key=>$name)
	$languages[]=array('lang'=>$key,'caption'=>$name,'selected'=>$key==A::$LANG);
	$this->Assign("languages",$languages);

	$this->Assign("isupdate",A_Session::get("isupdate",false));

    if(defined('TRIALBLOCKED'))
	$this->Assign('trialblocked',true);
	elseif(defined('TRIALTIME'))
	{ $trialdays=(integer)((2592000-TRIALTIME)/86400);
      $this->Assign('trialdays',$trialdays>0&&$trialdays<=10?$trialdays:0);
    }
  }
}

A::$MAINFRAME = new AdminMain;