<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

if(extension_loaded('zip'))
{
  class Zip extends ZipArchive
  {
    function addDir($path,$lpath='')
	{
      if(!empty($lpath))
	  $this->addEmptyDir($lpath);
      $files=scandir($path);
      foreach($files as $file)
	  if($file!='.' && $file!='..')
	  { if(is_dir($path.'/'.$file))
		$this->addDir($path.'/'.$file,!empty($lpath)?($lpath.'/'.$file):$file);
        elseif(is_file($path.'/'.$file))
		$this->addFile($path.'/'.$file,$lpath.'/'.$file);
      }
    }
  }
}

class SiteImport extends A_MainFrame
{
  static $eupdate=false;

  function __construct()
  {
    parent::__construct("site_import.tpl");
  }

  function Action($action)
  {
    @set_time_limit(0);

	$res=false;
	if(A::$AUTH->isSuperAdmin())
    switch($action)
	{ case "import": $res=$this->Import(); break;
	  case "export": $res=$this->Export(); break;
	}
	if($res)
	{ $link="admin.php?mode=site&item=import";
	  if($res!==true) $link.="&import=$res";
	  A::goUrl($link);
	}
	else
	A::goUrl("admin.php?mode=site&item=import&import=failed");
  }

  function install_extension($type,$name,$domain)
  {
    if(is_dir("files/".$domain."/tmp/extensions/{$type}s/{$name}"))
	{ if(copyDir("files/".$domain."/tmp/extensions/{$type}s/{$name}","{$type}s/{$name}",true))
	  { SiteImport::$eupdate=true;
	    return true;
	  }
	}
	return false;
  }

  function Import($DOMAIN=DOMAIN)
  {
    switch($_REQUEST['importmode'])
	{ case 1:
	    if(isset($_FILES['importfile']['tmp_name']))
		{ $path=$_FILES['importfile']['tmp_name'];
          if(empty($path) || !is_file($path))
		  return false;
		  $path_parts=pathinfo($_FILES['importfile']['name']);
	      $ext=preg_replace("/[^a-z0-9]+/i","",mb_strtolower($path_parts['extension']));
		}
		else
		return false;
		break;
	  case 2:
	    $path=$_REQUEST['importpath'];
        if(empty($path) || !is_file($path))
		return false;
		$path_parts=pathinfo($path);
	    $ext=preg_replace("/[^a-z0-9]+/i","",mb_strtolower($path_parts['extension']));
		break;
	  case 3:
	    if(isset($_FILES['configarch']['tmp_name']))
		{ $path=$_FILES['configarch']['tmp_name'];
          if(empty($path) || !is_file($path))
		  return false;
		  $path_parts=pathinfo($_FILES['configarch']['name']);
	      $ext=preg_replace("/[^a-z0-9]+/i","",mb_strtolower($path_parts['extension']));
		}
		else
		return false;
		break;
	}

	if($ext=='gz' || $ext=='zip')
	{
	  mk_dir("files/".$DOMAIN."/tmp");
	  clearDir("files/".$DOMAIN."/tmp");

	  if(extractArchive($path,"files/".$DOMAIN."/tmp",$ext))
	  {
		$xml = loadXML("files/".$DOMAIN."/tmp/configuration.xml",true);

		if(!$xml) return false;

		if($xml['system']>A::$OPTIONS['version'])
		return urlencode("Для импорта конфигурации необходима версия системы {$xml['system']} или выше.");
		if(!empty($xml['free']))
		return urlencode("Для импорта конфигурации необходима Astra.CMS Free.");

		$modules=A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='module'");
		$plugins=A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='plugin'");
		$blocks=A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='block'");

		$updates=array();

		if(!empty($xml['modules']['module']))
		{ if(!isset($xml['modules']['module'][0]))
		  $xml['modules']['module']=array($xml['modules']['module']);

		  foreach($xml['modules']['module'] as $module)
		  { if(!isset($modules[$module['name']]))
		    { if(!SiteImport::install_extension('module',$module['name'],$DOMAIN))
		      return urlencode("Для импорта конфигурации необходим установленный модуль '{$module['name']}'.");
		    }
			elseif($module['version']>$modules[$module['name']])
			{ if(SiteImport::install_extension('module',$module['name'],$DOMAIN))
			  { $from=(float)preg_replace("/[0-9]{2}$/","",$modules[$module['name']]);
			    $to=(float)preg_replace("/[0-9]{2}$/","",$module['version']);
			    if(($to-$from)>0)
			    $updates[]=array('type'=>'module','name'=>$module['name'],'from'=>$from,'to'=>$to);
			  }
			  else
		  	  return urlencode("Для импорта конфигурации необходим установленный модуль '{$module['name']}' версии {$module['version']} или выше.");
			}
			elseif($module['version']<$modules[$module['name']])
			{ $from=(float)preg_replace("/[0-9]{2}$/","",$module['version']);
			  $to=(float)preg_replace("/[0-9]{2}$/","",$modules[$module['name']]);
			  if(($to-$from)>0)
			  $updates[]=array('type'=>'module','name'=>$module['name'],'from'=>$from,'to'=>$to);
			}
		  }
		}

		if(!empty($xml['plugins']['plugin']))
		{ if(!isset($xml['plugins']['plugin'][0]))
		  $xml['plugins']['plugin']=array($xml['plugins']['plugin']);

		  foreach($xml['plugins']['plugin'] as $plugin)
		  { if(!isset($plugins[$plugin['name']]))
		    { if(!SiteImport::install_extension('plugin',$plugin['name'],$DOMAIN))
			  return urlencode("Для импорта конфигурации необходим установленный плагин '{$plugin['name']}'.");
			}
			elseif($plugin['version']>$plugins[$plugin['name']])
			{ if(SiteImport::install_extension('plugin',$plugin['name'],$DOMAIN))
			  { $from=(float)preg_replace("/[0-9]{2}$/","",$plugins[$plugin['name']]);
			    $to=(float)preg_replace("/[0-9]{2}$/","",$plugin['version']);
			    if(($to-$from)>0)
			    $updates[]=array('type'=>'plugin','name'=>$plugin['name'],'from'=>$from,'to'=>$to);
			  }
			  else
			  return urlencode("Для импорта конфигурации необходим установленный плагин '{$plugin['name']}' версии {$plugin['version']} или выше.");
			}
			elseif($plugin['version']<$plugins[$plugin['name']])
			{ $from=(float)preg_replace("/[0-9]{2}$/","",$plugin['version']);
			  $to=(float)preg_replace("/[0-9]{2}$/","",$plugins[$plugin['name']]);
			  if(($to-$from)>0)
			  $updates[]=array('type'=>'plugin','name'=>$plugin['name'],'from'=>$from,'to'=>$to);
			}
		  }
		}

		if(!empty($xml['blocks']['block']))
		{ if(!isset($xml['blocks']['block'][0]))
		  $xml['blocks']['block']=array($xml['blocks']['block']);

		  foreach($xml['blocks']['block'] as $block)
		  { if(!isset($blocks[$block['name']]))
		    { if(!SiteImport::install_extension('block',$block['name'],$DOMAIN))
			  return urlencode("Для импорта конфигурации необходим установленный блок '{$block['name']}'.");
			}
			elseif($block['version']>$blocks[$block['name']])
			{ if(!SiteImport::install_extension('block',$block['name'],$DOMAIN))
			  return urlencode("Для импорта конфигурации необходим установленный блок '{$block['name']}' версии {$block['version']} или выше.");
			}
		  }
		}

		if(is_dir("files/".$DOMAIN."/tmp/files"))
		{ $dh=opendir("files/".$DOMAIN);
          while($filename = readdir($dh))
          { if($filename=="." || $filename==".." || $filename=='tmp') continue;
            if(is_dir("files/".$DOMAIN."/".$filename))
			delDir("files/".$DOMAIN."/".$filename);
			else
			delfile("files/".$DOMAIN."/".$filename);
          }
          closedir($dh);

		  $dh=opendir("files/".$DOMAIN."/tmp/files");
          while($filename = readdir($dh))
          { if($filename=="." || $filename==".." || $filename=='tmp') continue;
            @rename("files/".$DOMAIN."/tmp/files/$filename","files/".$DOMAIN."/$filename");
          }
          closedir($dh);

          delFilesByDir("cache/images/".$DOMAIN);
		}

		if(is_dir("files/".$DOMAIN."/tmp/templates"))
		{ clearDir("templates/".$DOMAIN);
		  delFilesByDir("templates_c/".$DOMAIN);
		  copyDir("files/".$DOMAIN."/tmp/templates","templates/".$DOMAIN);
		  replaceDir("{TEMPLATESDIR}","/templates/".$DOMAIN,"templates/".$DOMAIN."/");
		}

		if(is_dir("files/".$DOMAIN."/tmp/db"))
		{
		  $tables=A::$DB->getTables($DOMAIN);
	      foreach($tables as $table)
	      if(preg_match("/^".$DOMAIN."_/i",$table))
	      A::$DB->execute("DROP TABLE `$table`");

		  A::$CACHE->resetDomain($DOMAIN);

          $i=0;
		  while($sql=@file_get_contents("files/".$DOMAIN."/tmp/db/dump{$i}.sql"))
          { $sql=str_replace("{DOMAIN}",$DOMAIN,$sql);
		    A::$DB->execSQL($sql,$DOMAIN);
			$i++;
		  }

		  $from=(float)preg_replace("/[0-9]{2}$/","",$xml['system']);
		  $to=(float)preg_replace("/[0-9]{2}$/","",A::$OPTIONS['version']);

		  for($v=$from;$v<$to;$v+=0.01)
		  { $sqlfile=str_replace(",",".",sprintf("system/sql-xml/domain_%.2f-%.2f.sql",$v,$v+0.01));
			if($sql=@file_get_contents($sqlfile))
		    A::$DB->execSQL(str_replace("{domain}",$DOMAIN,$sql),$DOMAIN);
		  }

		  foreach($updates as $update)
		  switch($update['type'])
		  { case "module":
		      $sections=getSectionsByModule($update['name'],$DOMAIN);
			  foreach($sections as $section)
			  { for($v=$update['from'];$v<$update['to'];$v+=0.01)
			    { $sqlfile=str_replace(",",".",sprintf("modules/{$update['name']}/sql-xml/update_%.2f-%.2f.sql",$v,$v+0.01));
				  if($sql=@file_get_contents($sqlfile))
		          { $sql=str_replace("{section}",$section,$sql);
		            $sql=str_replace("{section_id}",getSectionId($section),$sql);
			        $sql=str_replace("{domain}",$DOMAIN,$sql);
			        A::$DB->execSQL($sql,$DOMAIN);
			      }
				}
			  }
			  break;

		    case "plugin":
			  $structures=getStructuresByPlugin($update['name'],$DOMAIN);
			  foreach($structures as $structure)
			  { for($v=$update['from'];$v<$update['to'];$v+=0.01)
			    { $sqlfile=str_replace(",",".",sprintf("plugins/{$update['name']}/sql-xml/update_%.2f-%.2f.sql",$v,$v+0.01));
				  if($sql=@file_get_contents($sqlfile))
		          { $sql=str_replace("{structure}",$structure,$sql);
			        $sql=str_replace("{domain}",$DOMAIN,$sql);
			        A::$DB->execSQL($sql,$DOMAIN);
			      }
				}
			  }
			  break;
		  }
		}

		if(SiteImport::$eupdate)
		{ require_once("admin/system_extensions.php");
		  SystemExtensions::Update();
		}

		delDir("files/".$DOMAIN."/tmp");

		return "ok";
	  }
	}
    return false;
  }

  function Export()
  {
	mk_dir("files/".DOMAIN."/tmp");
    clearDir("files/".DOMAIN."/tmp");

	require_once('HTTP/Download.php');

	$usezip = $_REQUEST['type']=='zip' && extension_loaded('zip');

    if($usezip)
    { $zip = new Zip;
      $zip->open("files/".DOMAIN."/tmp/configuration.zip",ZIPARCHIVE::CREATE);
    }
    else
    { require_once("Archive/Tar.php");
	  $arch = new Archive_Tar("files/".DOMAIN."/tmp/configuration.tar.gz",true);
    }

	if(isset($_REQUEST['bd']))
	{
	  mk_dir("files/".DOMAIN."/tmp/db");

	  $this->mysqlbackup("files/".DOMAIN."/tmp/db");

      $i=0;
	  while($sql=@file_get_contents("files/".DOMAIN."/tmp/db/dump{$i}.sql"))
	  { $sql=str_replace("'".DOMAIN."_","'{DOMAIN}_",$sql);
	    $sql=str_replace("files/".DOMAIN."/","files/{DOMAIN}/",$sql);
	    $sql=str_replace("http://".HOSTNAME."/","/",$sql);
        delfile("files/".DOMAIN."/tmp/db/dump{$i}.sql");
        file_put_contents("files/".DOMAIN."/tmp/db/dump{$i}.sql",$sql);
		$i++;
	  }

	  if($usezip)
	  $zip->addDir("files/".DOMAIN."/tmp/db","db");
	  else
	  $arch->addModify(array("files/".DOMAIN."/tmp/db"),'',"files/".DOMAIN."/tmp");
	}

	if(isset($_REQUEST['theme']))
	{
	  copyDir("templates/".DOMAIN,"files/".DOMAIN."/tmp/templates");
	  replaceDir("/templates/".DOMAIN,"{TEMPLATESDIR}","files/".DOMAIN."/tmp/templates/");
	  if($usezip)
	  $zip->addDir("files/".DOMAIN."/tmp/templates","templates");
	  else
	  $arch->addModify(array("files/".DOMAIN."/tmp/templates"),'',"files/".DOMAIN."/tmp");
	}

	if(isset($_REQUEST['extensions']))
	{
	  mk_dir("files/".DOMAIN."/tmp/extensions");

	  A::$DB->query("SELECT DISTINCT module FROM ".DOMAIN."_sections ORDER BY module");
	  while($row=A::$DB->fetchRow())
	  { mk_dir("files/".DOMAIN."/tmp/extensions/modules");
	    copyDir("modules/".$row['module'],"files/".DOMAIN."/tmp/extensions/modules/{$row['module']}");
	  }
	  A::$DB->free();

	  A::$DB->query("SELECT DISTINCT plugin FROM ".DOMAIN."_structures ORDER BY plugin");
	  while($row=A::$DB->fetchRow())
	  { mk_dir("files/".DOMAIN."/tmp/extensions/plugins");
	    copyDir("plugins/".$row['plugin'],"files/".DOMAIN."/tmp/extensions/plugins/{$row['plugin']}");
	  }
	  A::$DB->free();

	  A::$DB->query("SELECT name FROM _extensions WHERE type='plugin' AND useauth='Y'");
	  while($row=A::$DB->fetchRow())
	  { mk_dir("files/".DOMAIN."/tmp/extensions/plugins");
	    copyDir("plugins/".$row['name'],"files/".DOMAIN."/tmp/extensions/plugins/{$row['name']}");
	  }
	  A::$DB->free();

	  A::$DB->query("SELECT DISTINCT block FROM ".DOMAIN."_blocks ORDER BY block");
	  while($row=A::$DB->fetchRow())
	  { mk_dir("files/".DOMAIN."/tmp/extensions/blocks");
	    copyDir("blocks/".$row['block'],"files/".DOMAIN."/tmp/extensions/blocks/{$row['block']}");
	  }
	  A::$DB->free();

      if($usezip)
	  $zip->addDir("files/".DOMAIN."/tmp/extensions","extensions");
	  else
	  $arch->addModify(array("files/".DOMAIN."/tmp/extensions"),'',"files/".DOMAIN."/tmp");
	}

	$data=array('system'=>A::$OPTIONS['version'],'name'=>'');
	$info=array('name','description','author','url');
	foreach($info as $fname)
	if(!empty($_REQUEST[$fname]))
	$data[$fname]=$_REQUEST[$fname];

	if(isset($_REQUEST['bd']) || file_exists("files/".DOMAIN."/tmp/extensions"))
	{
	  $modules=A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='module'");
	  $plugins=A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='plugin'");
	  $blocks=A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='block'");

	  A::$DB->query("SELECT DISTINCT module FROM ".DOMAIN."_sections ORDER BY module");
	  while($row=A::$DB->fetchRow())
	  $data['modules']['module'][]=array('name'=>$row['module'],'version'=>$modules[$row['module']]);
	  A::$DB->free();

	  A::$DB->query("SELECT DISTINCT plugin FROM ".DOMAIN."_structures ORDER BY plugin");
	  while($row=A::$DB->fetchRow())
	  $data['plugins']['plugin'][]=array('name'=>$row['plugin'],'version'=>$plugins[$row['plugin']]);
	  A::$DB->free();

	  A::$DB->query("SELECT name FROM _extensions WHERE type='plugin' AND useauth='Y'");
	  while($row=A::$DB->fetchRow())
	  $data['plugins']['plugin'][]=array('name'=>$row['name'],'version'=>$plugins[$row['name']]);
	  A::$DB->free();

	  A::$DB->query("SELECT DISTINCT block FROM ".DOMAIN."_blocks ORDER BY block");
	  while($row=A::$DB->fetchRow())
	  $data['blocks']['block'][]=array('name'=>$row['block'],'version'=>$blocks[$row['block']]);
	  A::$DB->free();
	}

	file_put_contents("files/".DOMAIN."/tmp/configuration.xml",getXML($data,'configuration'));

	if($usezip)
	$zip->addFile("files/".DOMAIN."/tmp/configuration.xml","configuration.xml");
	else
	$arch->addModify(array("files/".DOMAIN."/tmp/configuration.xml"),'',"files/".DOMAIN."/tmp");

	if(isset($_REQUEST['files']))
	{ $files=$_files=array();
	  $dh=opendir("files/".DOMAIN);
      while($filename = readdir($dh))
      { if($filename=="." || $filename==".." || $filename=='tmp') continue;
        $files[]=$filename;
        $_files[]="files/".DOMAIN."/".$filename;
      }
      closedir($dh);

	  if($usezip)
	  { foreach($files as $file)
	    if(is_dir("files/".DOMAIN."/".$file))
	    $zip->addDir("files/".DOMAIN."/".$file,"files/$file");
	    elseif(is_file("files/".DOMAIN."/".$file))
	    $zip->addFile("files/".DOMAIN."/".$file,"files/".$file);
	  }
	  else
	  $arch->addModify($_files,'files',"files/".DOMAIN);
	}


	if($usezip)
	{ $zip->close();
	  if(file_exists("files/".DOMAIN."/tmp/configuration.zip"))
	  { $params['file'] = "files/".DOMAIN."/tmp/configuration.zip";
        $params['contenttype'] = "application/zip";
        $params['contentdisposition'] = array(HTTP_DOWNLOAD_ATTACHMENT, DOMAIN.".zip");
	    HTTP_Download::staticSend($params, false);
        return true;
      }
	}
	elseif(file_exists("files/".DOMAIN."/tmp/configuration.tar.gz"))
    { $params['file'] = "files/".DOMAIN."/tmp/configuration.tar.gz";
      $params['contenttype'] = "application/gzip";
      $params['contentdisposition'] = array(HTTP_DOWNLOAD_ATTACHMENT, DOMAIN.".tar.gz");
	  HTTP_Download::staticSend($params, false);
      return true;
	}
	else
	return false;
  }

  function mysqlbackup($path,$structure_only=false,$crlf="\n")
  {
    A::$DB->Connect(DOMAIN);
	$result=A::$DB->__execute("SELECT VERSION() AS version");
    if($result != FALSE && $result->num_rows > 0)
	{ $row   = $result->fetch_array();
      $match = explode('.', $row['version']);
    } else {
    $result=A::$DB->__execute("SHOW VARIABLES LIKE \'version\'");
    if ($result != FALSE && $result->num_rows > 0){
     $row   = $result->fetch_row();
     $match = explode('.', $row[1]);
    }
    }

    $strfrom = array('\\','\'',"\x00","\x0a","\x0d","\x1a");
    $strto = array('\\\\','\\\'','\0','\n','\r','\Z');

    if (!isset($match) || !isset($match[0])) {
     $match[0] = 3;
    }
    if (!isset($match[1])) {
     $match[1] = 21;
    }
    if (!isset($match[2])) {
     $match[2] = 0;
    }
    if(!isset($row)) {
     $row = '3.21.0';
    }

    define('MYSQL_INT_VERSION', (integer)sprintf('%d%02d%02d', $match[0], $match[1], intval($match[2])));
    define('MYSQL_STR_VERSION', $row['version']);
    unset($match);

	$filecount=0;
	$cursize=0;
    $fp = fopen($path."/dump{$filecount}.sql","wb");

    $sql = "";

    $tables=A::$DB->getTables();

	foreach($tables as $tablename)
	{

    if(!preg_match("/^".DOMAIN."_/i",$tablename))
    continue;

    $tablenameout=preg_replace("/^".DOMAIN."_/i","{DOMAIN}_",$tablename);

    $sql="";

    $sql.="DROP TABLE IF EXISTS `$tablenameout`;".$crlf;
    $sql.="CREATE TABLE `$tablenameout`(".$crlf;

    $types=array();
    $result=A::$DB->__execute("show fields  from `$tablename`");

    while ($row = $result->fetch_array())
	{ $types[]=preg_replace("/\(.+$/i","",$row['Type']);
      $sql .= "  `".$row['Field']."`";
      $sql .= ' ' . $row['Type'];
      if($row['Null'] != 'YES')
      $sql.=' NOT NULL';
	  if(isset($row['Default']))
      $sql.=' DEFAULT \'' . $row['Default'] . '\'';
      if($row['Extra'] != '')
      $sql .= ' ' . $row['Extra'];
      $sql .= ",".$crlf;
   }

   $result->free();
   $sql = preg_replace('/,' . $crlf . '$/i', '', $sql);

   $index=array();
   $result = A::$DB->__execute("SHOW KEYS FROM `$tablename`");
    while ($row = $result->fetch_array()) {
     $ISkeyname    = $row['Key_name'];
	 $Index_type = (isset($row['Index_type'])) ? $row['Index_type'] : '';
     $ISsub_part = (isset($row['Sub_part'])) ? $row['Sub_part'] : '';
     if (mb_strtoupper($ISkeyname) != 'PRIMARY' && $row['Non_unique'] == 0) {
      $ISkeyname = "UNIQUE|$ISkeyname";
     }
     if (mb_strtoupper($Index_type) == 'FULLTEXT') {
      $ISkeyname = "FULLTEXT|$ISkeyname";
     }
     if (!isset($index[$ISkeyname])) {
      $index[$ISkeyname] = array();
     }
     if ($ISsub_part > 1) {
      $index[$ISkeyname][] = "`".$row['Column_name'].'`(' . $ISsub_part . ')';
     } else {
      $index[$ISkeyname][] = "`".$row['Column_name']."`";
     }
    }
    $result->free();

    while (list($x, $columns) = @each($index)) {
     $sql     .= ",".$crlf;
     if ($x == 'PRIMARY') {
      $sql .= '  PRIMARY KEY (';
      } else if (mb_substr($x, 0, 6) == 'UNIQUE') {
      $sql .= '  UNIQUE `' . mb_substr($x, 7) . '` (';
     } else if (mb_substr($x, 0, 8) == 'FULLTEXT') {
      $sql .= '  FULLTEXT `' . mb_substr($x, 9) . '` (';
     } else {
      $sql .= '  KEY `' . $x . '` (';
     }
     $sql     .= implode($columns, ', ') . ')';
    }
    $sql .=  $crlf.") ENGINE=MyISAM DEFAULT CHARSET=utf8;".$crlf.$crlf;

  fwrite($fp,$sql);
  $cursize+=mb_strlen($sql);
  if($cursize>614400)
  { fclose($fp);
    $filecount++;
	$cursize=0;
    $fp = fopen($path."/dump{$filecount}.sql","wb");
  }

 if($structure_only == FALSE)
 {
  $result = A::$DB->__execute("SELECT * FROM  `$tablename`");

  $fields_info = $result->fetch_fields();
  $fields_cnt   = count($fields_info);

  while ($row = $result->fetch_row()) {
   $table_list     = '(';
   for ($j = 0; $j < $fields_cnt; $j++) {
    $table_list .= $fields_info[$j]->name . ', ';
   }
   $table_list = mb_substr($table_list, 0, -2);
   $table_list     .= ')';

   $sql = 'INSERT INTO `'.$tablenameout.'` VALUES (';
   for ($j = 0; $j < $fields_cnt; $j++) {
    if (!isset($row[$j])) {
     $sql .= ' NULL, ';
    } else if ($row[$j] == '0' || $row[$j] != '')
	{

     $type = strtolower($types[$j]);

     if($type == 'tinyint' || $type == 'smallint' || $type == 'mediumint' || $type == 'int' ||
                        $type == 'bigint'  ||$type == 'timestamp') {
      $sql .= $row[$j] . ', ';
     }
	 elseif($type == 'tinyblob' || $type == 'smallblob' || $type == 'mediumblob' || $type == 'blob' || $type == 'bigblob')
	 {
	   if (empty($row[$j]) && $row[$j] != '0')
	   $sql .= '\'\', ';
       else
	   $sql .= '0x' . bin2hex($row[$j]).', ';
	 }
     else
	 {
        $dummy = str_replace($strfrom,$strto,$row[$j]);
        $sql .= "'" . $dummy . "', ";
     }
    } else {
     $sql .= "'', ";
    }
   }
   $sql = preg_replace('/, $/i', '', $sql);
   $sql .= ");".$crlf;
   fwrite($fp,$sql);
   $cursize+=mb_strlen($sql);
   if($cursize>614400)
   { fclose($fp);
     $filecount++;
	 $cursize=0;
     $fp = fopen($path."/dump{$filecount}.sql","wb");
   }

  } $result->free(); fwrite($fp,$crlf);  } }  fclose($fp);
  }

  function createData()
  {
	$this->Assign("caption","Импорт / Экспорт");

	if(!empty($_REQUEST['import']))
	switch($_REQUEST['import'])
	{ case 'ok': $this->Assign("debugdata",'<script type="text/javascript">alert("Импорт успешно завершен.")</script>'); break;
	  case 'failed': $this->Assign("debugdata",'<script type="text/javascript">alert("Не удалось импортировать файл.")</script>'); break;
	  default: $this->Assign("debugdata",'<script type="text/javascript">alert("'.$_REQUEST['import'].'")</script>'); break;
    }

    $this->Assign("usezip",extension_loaded('zip'));
  }
}

A::$MAINFRAME = new SiteImport;