<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SiteLanguages extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("site_languages.tpl");

	$this->AddJScript("/admin/jscripts/site_languages.js");
  }

  function Action($action)
  {
    $res=false;
    switch($action)
	{ case "add": $res=$this->Add(); break;
	  case "edit": $res=$this->Edit(); break;
	  case "del": $res=$this->Del(); break;
	}
	if($res)
	A::goUrl("admin.php?mode=site&item=languages");
  }

  function Add()
  {
	$_REQUEST['name']=mb_substr(mb_strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",$_REQUEST['name'])),0,5);
	$_REQUEST['caption']=strip_tags($_REQUEST['caption']);

	if(empty($_REQUEST['name']) || $_REQUEST['name']=="all" || A::$DB->existsRow("SELECT * FROM ".DOMAIN."_languages WHERE name=?",$_REQUEST['name']))
	{ $this->errors['doubleid']=true;
	  return false;
	}

	$_REQUEST['sort']=A::$DB->getOne("SELECT MAX(sort) FROM ".DOMAIN."_languages")+1;

	$dataset = new A_DataSet(DOMAIN."_languages");
	$dataset->fields=array("name","caption","sort");
	if($dataset->Insert())
	{
	  A::$DB->execute("ALTER TABLE `".DOMAIN."_sections` ADD `caption_{$_REQUEST['name']}` VARCHAR(100) NOT NULL DEFAULT ''");
	  A::$DB->execute("ALTER TABLE `".DOMAIN."_sections` ADD `title_{$_REQUEST['name']}` VARCHAR(255) NOT NULL DEFAULT ''");
   	  A::$DB->execute("ALTER TABLE `".DOMAIN."_fields` ADD `name_{$_REQUEST['name']}` VARCHAR(100) NOT NULL DEFAULT ''");

	  A::$DB->Insert(DOMAIN."_options",array('name'=>'Название сайта','var'=>"sitename_{$_REQUEST['name']}",'type'=>'string'));
	  A::$DB->Insert(DOMAIN."_options",array('name'=>'Заголовок сайта','var'=>"sitetitle_{$_REQUEST['name']}",'type'=>'string'));

	  A::$CACHE->resetDomain(DOMAIN);

	  A::$OBSERVER->Event('AddLanguage',$_REQUEST['name'],$_REQUEST);

	  return true;
	}
	else
	return false;
  }

  function Edit()
  {
	$_REQUEST['name']=mb_substr(mb_strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",$_REQUEST['name'])),0,5);
	$_REQUEST['caption']=strip_tags($_REQUEST['caption']);

	if(empty($_REQUEST['name']) || $_REQUEST['name']=="all" || A::$DB->existsRow("SELECT * FROM ".DOMAIN."_languages WHERE name=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['name']))
	{ $this->errors['doubleid']=true;
	  return false;
	}

   	$dataset = new A_DataSet(DOMAIN."_languages");
	$dataset->fields=array("name","caption");
	if($row=$dataset->Update())
	{
	  if($_REQUEST['name']!=$row['name'])
	  {
		A::$DB->execute("ALTER TABLE `".DOMAIN."_sections` CHANGE `caption_{$row['name']}` `caption_{$_REQUEST['name']}` VARCHAR(100) NOT NULL DEFAULT ''");
	    A::$DB->execute("ALTER TABLE `".DOMAIN."_sections` CHANGE `title_{$row['name']}` `title_{$_REQUEST['name']}` VARCHAR(255) NOT NULL DEFAULT ''");
	    A::$DB->execute("ALTER TABLE `".DOMAIN."_fields` CHANGE `name_{$row['name']}` `name_{$_REQUEST['name']}` VARCHAR(100) NOT NULL DEFAULT ''");
		A::$DB->execute("UPDATE ".DOMAIN."_sections SET lang='".$_REQUEST['name']."' WHERE lang='".$row['name']."'");
		A::$DB->execute("UPDATE ".DOMAIN."_blocks SET lang='".$_REQUEST['name']."' WHERE lang='".$row['name']."'");
		A::$DB->Update(DOMAIN."_options",array('var'=>"sitename_{$_REQUEST['name']}"),"item='' AND var='sitename_{$row['name']}'");
		A::$DB->Update(DOMAIN."_options",array('var'=>"sitetitle_{$_REQUEST['name']}"),"item='' AND var='sitetitle_{$row['name']}'");

		$tables=A::$DB->getTables();

		foreach($tables as $table)
		if(preg_match("/^".DOMAIN."_".$row['name']."/i",$table,$match))
		{ $newtable=preg_replace("/^".DOMAIN."_".$row['name']."/i",DOMAIN."_".$_REQUEST['name'],$table);
		  A::$DB->execute("ALTER TABLE `$table` RENAME `$newtable`");
		}

        A::$DB->query("SELECT id,item FROM ".DOMAIN."_options");
		while($crow=A::$DB->fetchRow())
		if(preg_match("/^".DOMAIN."_".$row['name']."_/i",$crow['item'],$match))
		{ $section=preg_replace("/^".DOMAIN."_".$row['name']."/i",DOMAIN."_".$_REQUEST['name'],$crow['item']);
		  A::$DB->execute("UPDATE ".DOMAIN."_options SET item='$section' WHERE id=".$crow['id']);
		}
		A::$DB->free();

		A::$DB->query("SELECT id,item,itemeditor FROM ".DOMAIN."_blocks");
		while($crow=A::$DB->fetchRow())
		{ if(preg_match("/^".DOMAIN."_".$row['name']."_/i",$crow['item'],$match))
		  { $section=preg_replace("/^".DOMAIN."_".$row['name']."/i",DOMAIN."_".$_REQUEST['name'],$crow['item']);
		    A::$DB->execute("UPDATE ".DOMAIN."_blocks SET item='$section' WHERE id=".$crow['id']);
		  }
		  if(preg_match("/^".DOMAIN."_".$row['name']."_/i",$crow['itemeditor'],$match))
		  { $section=preg_replace("/^".DOMAIN."_".$row['name']."/i",DOMAIN."_".$_REQUEST['name'],$crow['itemeditor']);
		    A::$DB->execute("UPDATE ".DOMAIN."_blocks SET itemeditor='$section' WHERE id=".$crow['id']);
		  }
		}
		A::$DB->free();

		A::$DB->query("SELECT id,item FROM ".DOMAIN."_fields");
		while($crow=A::$DB->fetchRow())
		if(preg_match("/^".DOMAIN."_".$row['name']."_/i",$crow['item'],$match))
		{ $section=preg_replace("/^".DOMAIN."_".$row['name']."/i",DOMAIN."_".$_REQUEST['name'],$crow['item']);
		  A::$DB->execute("UPDATE ".DOMAIN."_fields SET item='$section' WHERE id=".$crow['id']);
		}
		A::$DB->free();

        if(A::$LANG==$row['name'])
		A_Session::set("A_LANG",$_REQUEST['name']);

	    A::$CACHE->resetDomain(DOMAIN);

		A::$OBSERVER->Event('UpdateLanguage',$_REQUEST['name'],$_REQUEST);
	  }

	  return true;
	}
	else
	return false;
  }

  function Del()
  {
	$dataset = new A_DataSet(DOMAIN."_languages");
	if($drow=$dataset->Delete())
	{
	  A::$DB->execute("ALTER TABLE `".DOMAIN."_sections` DROP `caption_{$drow['name']}`");
	  A::$DB->execute("ALTER TABLE `".DOMAIN."_sections` DROP `title_{$drow['name']}`");
	  A::$DB->execute("ALTER TABLE `".DOMAIN."_fields` DROP `name_{$drow['name']}`");
	  A::$DB->execute("DELETE FROM ".DOMAIN."_options WHERE item='' AND var='sitename_{$drow['name']}'");
	  A::$DB->execute("DELETE FROM ".DOMAIN."_options WHERE item='' AND var='sitetitle_{$drow['name']}'");

	  $lcount=A::$DB->getOne("SELECT COUNT(*) FROM ".DOMAIN."_languages");

	  include("admin/site_sections.php");

	  A::$DB->query("SELECT * FROM ".DOMAIN."_sections ORDER BY sort");
	  while($row=A::$DB->fetchRow())
	  if($row['lang']==$drow['name'] || ($lcount<2 && $row['lang']=='all'))
	  SiteSections::Del($row['id']);
	  A::$DB->free();

	  if(A::$LANG==$drow['name'])
	  A_Session::unregister("A_LANG");

	  A::$CACHE->resetDomain(DOMAIN);

	  A::$OBSERVER->Event('DeleteLanguage',$drow['name'],$drow);

	  return true;
	}
	return false;
  }

  function createData()
  {
	$this->Assign("caption","Языковые версии");

    $languages=array();
	A::$DB->query("SELECT * FROM ".DOMAIN."_languages ORDER BY sort");
    while($row=A::$DB->fetchRow())
	$languages[]=$row;
	A::$DB->free();

    $this->Assign("langs",$languages);
  }
}

A::$MAINFRAME = new SiteLanguages;