<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SiteStructures extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("site_structures.tpl");

	$this->AddJScript("/admin/jscripts/site_structures.js");
  }

  function Action($action)
  {
    $res=false;
    switch($action)
	{ case "add": $res=$this->Add(); break;
	  case "edit": $res=$this->Edit(); break;
	  case "del": $res=$this->Del(); break;
	  case "save": $res=$this->Save(); break;
	  case "delete": $res=$this->Delete(); break;
	}
	if($res)
	A::goUrl("admin.php?mode=site&item=structures");
  }

  function Add()
  {
    $_REQUEST['name']=mb_substr(mb_strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",$_REQUEST['name'])),0,20);
	$_REQUEST['plugin']=mb_substr(preg_replace("/[^a-zA-Z0-9_-]+/i","",$_REQUEST['plugin']),0,20);
	$_REQUEST['caption']=strip_tags($_REQUEST['caption']);

	if(A::$DB->existsRow("SELECT * FROM ".DOMAIN."_structures WHERE name=?",$_REQUEST['name']))
	{ $this->errors['doubleid']=true;
	  return false;
	}

	if($xml=loadXML('plugins/'.$_REQUEST['plugin'].'/sql-xml/install.xml',true))
	{ if(!empty($xml['hidden']))
	  return false;
	}
	else
	return false;

	$_REQUEST['sort']=A::$DB->getOne("SELECT MAX(sort) FROM ".DOMAIN."_structures")+1;
	$_REQUEST['icon']=isset($_REQUEST['icon'])?'Y':'N';
	$_REQUEST['menu']=isset($_REQUEST['menu'])?'Y':'N';

	$dataset = new A_DataSet(DOMAIN."_structures");
    $dataset->fields=array("plugin","itemeditor","name","caption","sort","icon","menu");

    if($_REQUEST['id']=$dataset->Insert())
    {
	  $structure=DOMAIN."_structure_".$_REQUEST['name'];

      if($sql=@file_get_contents("plugins/".$_REQUEST['plugin']."/sql-xml/create.sql"))
      { $sql=str_replace("{structure}",$structure,$sql);
	    $sql=str_replace("{domain}",DOMAIN,$sql);
        try
		{ A::$DB->execSQL($sql);
		}
		catch(exception $exception)
		{ print $exception->__toString().'<br>';
		  A::$DB->Delete(DOMAIN."_structures","id=".$_REQUEST['id']);
		  return false;
		}
      }

	  if($data=loadXML("plugins/".$_REQUEST['plugin']."/sql-xml/options.xml",true))
	  if(!empty($data['option']))
	  { if(isset($data['option']['var']))
	    $data['option']=array($data['option']);
	    foreach($data['option'] as $option)
	    { $option['item']=$structure;
	      $option['name']=$option['name'];
		  if(!empty($option['value']))
		  $option['value']=$option['value'];
		  if(!empty($option['options']))
		  { $options=array();
		    foreach($option['options'] as $var=>$value)
		    $options[str_replace("_"," ",$var)]=$value;
		    $option['options']=serialize($options);
		  }
	      A::$DB->Insert(DOMAIN."_options",$option);
	    }
	  }

	  copyDir("plugins/".$_REQUEST['plugin']."/templates/default","templates/".DOMAIN);

	  if(file_exists("plugins/".$_REQUEST['plugin']."/include.php"))
	  require_once("plugins/".$_REQUEST['plugin']."/include.php");

	  A::$OBSERVER->Event('CreateStructure',$structure,$_REQUEST);

	  return true;
    }
    return false;
  }

  function Edit()
  {
    $_REQUEST['name']=mb_substr(mb_strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",$_REQUEST['name'])),0,20);
    $_REQUEST['caption']=strip_tags($_REQUEST['caption']);

	if(A::$DB->existsRow("SELECT * FROM ".DOMAIN."_structures WHERE name=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['name']))
	{ $this->errors['doubleid']=true;
	  return false;
	}

	$_REQUEST['icon']=isset($_REQUEST['icon'])?'Y':'N';
	$_REQUEST['menu']=isset($_REQUEST['menu'])?'Y':'N';

    $dataset = new A_DataSet(DOMAIN."_structures");
    $dataset->fields=array("name","itemeditor","caption","icon","menu");

    if($row=$dataset->Update())
    { if($_REQUEST['name']!=$row['name'])
      {
	    $structure=DOMAIN."_structure_".$_REQUEST['name'];
		$oldstructure=DOMAIN."_structure_".$row['name'];

		$tables=A::$DB->getTables();
		foreach($tables as $table)
		if(preg_match("/^".$oldstructure."/i",$table))
		{ $newtable=preg_replace("/^".$oldstructure."/i",$structure,$table);
		  A::$DB->execute("ALTER TABLE `$table` RENAME `$newtable`");
		}

        A::$DB->execute("UPDATE ".DOMAIN."_blocks SET item='$structure' WHERE item='$oldstructure'");
		A::$DB->execute("UPDATE ".DOMAIN."_options SET item='$structure' WHERE item='$oldstructure'");
		A::$DB->execute("UPDATE ".DOMAIN."_fields SET item='$structure' WHERE item='$oldstructure'");
      }

	  A::$OBSERVER->Event('UpdateStructure',DOMAIN."_structure_".$row['name'],$_REQUEST);

	  return true;
    }
    return false;
  }

  function Del($id=0)
  {
    if($id>0)
	$_REQUEST['id']=$id;

    $dataset = new A_DataSet(DOMAIN."_structures");
    if($row=$dataset->Delete())
    {
	  $structure=DOMAIN."_structure_".$row['name'];

      $tables=A::$DB->getTables();
	  foreach($tables as $table)
	  if(preg_match("/^".$structure."/i",$table))
	  { A::$DB->execute("DROP TABLE `$table`");
	    if(A::$DB->caching==1)
		delDir('cache/db/'.$table);
	  }

	  A::$DB->execute("DELETE FROM ".DOMAIN."_options WHERE item='$structure'");
	  A::$DB->execute("DELETE FROM ".DOMAIN."_blocks WHERE item='$structure'");
	  A::$DB->execute("DELETE FROM ".DOMAIN."_fields WHERE item='$structure'");

	  A::$OBSERVER->Event('DeleteStructure',$structure);

	  return true;
    }
    else
    return false;
  }

  function Delete()
  {
    if(isset($_REQUEST['checkstructure']))
	foreach($_REQUEST['checkstructure'] as $id)
	$this->Del($id);
	return true;
  }

  function createData()
  {
	$this->Assign("caption","Дополнения");

	$structures=array();
    A::$DB->query("SELECT * FROM ".DOMAIN."_structures ORDER BY sort");
    while($row=A::$DB->fetchRow())
    { $structure=DOMAIN."_structure_".$row['name'];
	  $row['structure']=$structure;
	  $ico="plugins/".$row['plugin']."/ico.gif";
	  $row['ico']=file_exists($ico)?AddImage('/'.$ico,16,16,$row['caption']):AddImage("/templates/admin/images/icons/main_structures.gif",16,16);
	  $row['modcaption']=A::$DB->getOne("SELECT caption FROM _extensions WHERE type='plugin' AND name=?",$row['plugin']);
	  $structures[]=$row;
    }

    $this->Assign("structures",$structures);
	$this->AddJVar("cstructures",count($structures));
  }
}

A::$MAINFRAME = new SiteStructures;