<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 " "
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SiteStructures_Request extends A_Request
{
  function Action($action)
  {
    switch($action)
	{ case "getaddstructureform": $this->getAddStructureForm(); break;
	  case "geteditstructureform": $this->getEditStructureForm(); break;
	  case "getnewname": $this->getNewName(); break;
	  case "setsort": $this->setSort(); break;
	}
  }

  function in_extensions($owner,$extensions)
  {
    foreach($extensions as $extname)
	if(preg_match("/^".$owner."/i",$extname))
	return true;
	return false;
  }

  function getAddStructureForm()
  {
    $form = new A_Form("site_structures_add.tpl");

    $extensions=array();
	A::$DB->query("SELECT DISTINCT module FROM ".DOMAIN."_sections");
	while($row=A::$DB->fetchRow())
	$extensions[]=$row['module'];
	A::$DB->free();

	A::$DB->query("SELECT * FROM _extensions WHERE type='plugin' AND useauth='N' ORDER BY sort,id");
    while($row=A::$DB->fetchRow())
	{ if($row['multiple']=='N')
	  { if(A::$DB->getRow("SELECT id FROM ".DOMAIN."_structures WHERE plugin='{$row['name']}'"))
	    continue;
	  }
	  if(!empty($row['owner']))
	  { $f=false;
	    $owners=explode(",",$row['owner']);
	    foreach($owners as $owner)
	    if(!$f=$this->in_extensions($owner,$extensions))
	    break;
		if(!$f)
	    continue;
	  }
	  if($xml=loadXML('plugins/'.$row['name'].'/sql-xml/install.xml',true))
	  { if(!empty($xml['hidden']))
	    continue;
	  }
	  $form->data['plugins'][$row['name']]=$row['caption'];
	}
	A::$DB->free();

	$form->data['items']=array();
	A::$DB->query("SELECT * FROM ".DOMAIN."_sections ORDER BY sort");
    while($row=A::$DB->fetchRow())
    { $item=DOMAIN."_".$row['lang']."_".$row['name'];
	  $form->data['items'][$item]=$row['caption'];
	}

	for($i=1;$i<50;$i++)
    { $name="app$i";
      if(!A::$DB->existsRow("SELECT id FROM ".DOMAIN."_sections WHERE name=?",$name))
      { $form->data['name']=$name;
        break;
      }
    }

	$this->RESULT['html']=$form->getContent();
  }

  function getEditStructureForm()
  {
    $form = new A_Form("site_structures_edit.tpl");

    $form->data=A::$DB->getRowById($_POST['id'],DOMAIN."_structures");

	$form->data['items']=array();
	A::$DB->query("SELECT * FROM ".DOMAIN."_sections ORDER BY sort");
    while($row=A::$DB->fetchRow())
    { $item=DOMAIN."_".$row['lang']."_".$row['name'];
	  $form->data['items'][$item]=$row['caption'];
	}

	$this->RESULT['html']=$form->getContent();
  }

  function getNewName()
  {
    $base=!empty($_POST['plugin'])?preg_replace("/[^a-zA-Z0-9]/i","",$_POST['plugin']):"newapp";
    if(!A::$DB->existsRow("SELECT id FROM ".DOMAIN."_structures WHERE name=?",$base))
    $this->RESULT['name']=$base;
    else
	for($i=1;$i<50;$i++)
    { $name=$base.$i;
      if(!A::$DB->existsRow("SELECT id FROM ".DOMAIN."_structures WHERE name=?",$name))
      { $this->RESULT['name']=$name;
        break;
      }
    }
  }

  function setSort()
  {
    $sort=!empty($_POST['sort'])?explode(",",$_POST['sort']):array();
	$i=1;
	foreach($sort as $id)
	A::$DB->Update(DOMAIN."_structures",array('sort'=>$i++),"id=".(integer)$id);
  }
}

A::$REQUEST = new SiteStructures_Request;