<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SystemAdmins extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("system_admins.tpl");

	$this->AddJScript("/admin/jscripts/system_admins.js");
  }

  function Action($action)
  {
    $res=false;
	switch($action)
	{ case "add": $res=$this->Add(); break;
	  case "edit": $res=$this->Edit(); break;
	  case "del": $res=$this->Del(); break;
	}
	if($res)
	A::goUrl("admin.php?mode=system&item=admins",array('page'));
  }

  function Add()
  {
  	if(A::$DB->existsRow("SELECT * FROM _auth WHERE login=?",$_REQUEST['login']))
	{ $this->errors['doublelogin']=true;
	  return false;
	}

    $_REQUEST['password']=md5($_REQUEST['password']);

	if(isset($_REQUEST['check_accessall']))
	$_REQUEST['access']='';
	else
	{ $access=array();
	  if(!empty($_REQUEST['domains']))
	  foreach($_REQUEST['domains'] as $domain)
	  $access[$domain]=array();
	  if(!empty($_REQUEST['items']))
	  foreach($_REQUEST['items'] as $item)
	  $access[getDomain($item)][]=$item;
	  $_REQUEST['access']=!empty($access)?serialize($access):'';
	}

	$_REQUEST['date']=time();
	$_REQUEST['expert']=isset($_REQUEST['expert'])?'Y':'N';
	$_REQUEST['active']=isset($_REQUEST['active'])?'Y':'N';


	$scount=A::$DB->getOne("SELECT COUNT(*) FROM `_auth` WHERE access='' OR ISNULL(access)");
    if(!empty($_REQUEST['access']) && $scount<1)
	$_REQUEST['access']='';

	$dataset = new A_DataSet("_auth");
	$dataset->fields=array("date","name","login","password","email","access","expert","active");
	return $dataset->Insert();
  }

  function Edit()
  {
	if(empty($_REQUEST['id'])) return false;

	if(A::$DB->existsRow("SELECT * FROM _auth WHERE login=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['login']))
	{ $this->errors['doublelogin']=true;
	  return false;
	}

	if(isset($_REQUEST['check_accessall']))
	$_REQUEST['access']='';
	else
	{ $access=array();
	  $domains=array();
	  if(!empty($_REQUEST['domains']))
	  foreach($_REQUEST['domains'] as $domain)
	  { $access[$domain]=array();
	    $domains[]=$domain;
	  }
	  if(!empty($_REQUEST['items']))
	  foreach($_REQUEST['items'] as $item)
	  if(!in_array(getDomain($item),$domains))
	  $access[getDomain($item)][]=$item;
	  $_REQUEST['access']=!empty($access)?serialize($access):'';
	}

	$_REQUEST['expert']=isset($_REQUEST['expert'])?'Y':(A::$AUTH->id!=(integer)$_REQUEST['id']?'N':'Y');
	$_REQUEST['active']=isset($_REQUEST['active'])?'Y':(A::$AUTH->id!=(integer)$_REQUEST['id']?'N':'Y');

	$scount=A::$DB->getOne("SELECT COUNT(*) FROM `_auth` WHERE (access='' OR ISNULL(access)) AND id<>".(integer)$_REQUEST['id']);
    if(!empty($_REQUEST['access']) && $scount<1)
	$_REQUEST['access']='';

    $dataset = new A_DataSet("_auth");
	$dataset->fields=array("name","login","email","access","expert","active");
    if(mb_strlen($_REQUEST['password'])>=4)
    { $_REQUEST['password']=md5($_REQUEST['password']);
	  $dataset->fields[]="password";
	}
	return $dataset->Update();
  }

  function Del()
  {
    if($_REQUEST['id']!=A::$AUTH->id)
	{
      A::$DB->execute("DELETE FROM _auth WHERE id=".(integer)$_REQUEST['id']);
	  return true;
	}
	else
	return false;
  }

  function isAdmin($access)
  {
    foreach($access as $domain=>$items)
	if(count($items)==0) return true;
	return false;
  }

  function createData()
  {
	$this->Assign("caption","Администраторы");

    $admins=array();
    $pager = new A_Pager(20);
	$pager->query("SELECT * FROM _auth ORDER BY id");
    while($row=$pager->fetchRow())
    { $row['access']=!empty($row['access'])?unserialize($row['access']):array();
	  $row['issuperadmin']=count($row['access'])==0;
	  $row['isadmin']=count($row['access'])==0 || $this->isAdmin($row['access']);
	  $admins[]=$row;
    }
    $pager->free();

    $this->Assign("admins",$admins);
    $this->Assign("admins_pager",$pager);
  }
}

A::$MAINFRAME = new SystemAdmins;