<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SystemAdmins_Request extends A_Request
{
  function Action($action)
  {
    switch($action)
	{ case "getaddadminform": $this->getAddAdminForm(); break;
	  case "geteditadminform": $this->getEditAdminForm(); break;
	}
  }

  function getAddAdminForm()
  {
    $form = new A_Form("system_admins_add.tpl");

	$form->data['domains']=array();
	$form->data['sdomains']=array();

    A::$DB->query("SELECT * FROM _domains ORDER BY domain");
	while($drow=A::$DB->fetchRow())
	{
	  $form->data['sdomains'][$drow['name']]=$drow['domain'];

	  $sections=array();
	  A::$DB->query("SELECT name,caption,lang FROM {$drow['name']}_sections WHERE active='Y' AND (icon='Y' OR menu='Y') ORDER BY sort");
	  while($row=A::$DB->fetchRow())
	  { $row['section']=$drow['name']."_".$row['lang']."_".$row['name'];
	    $sections[]=$row;
	  }
	  A::$DB->free();

	  $structures=array();
	  A::$DB->query("SELECT name,caption FROM {$drow['name']}_structures WHERE icon='Y' OR menu='Y' ORDER BY sort");
	  while($row=A::$DB->fetchRow())
	  { $row['structure']=$drow['name']."_structure_".$row['name'];
	    $structures[]=$row;
	  }
	  A::$DB->free();

	  $domain=array(
	  'domain'=>$drow['domain'],
	  'name'=>$drow['name'],
	  'sections'=>$sections,
	  'structures'=>$structures,
	  'files'=>array());

	  $domain['files'][]=array('caption'=>'Файловый менеджер','item'=>$drow['name'].'_files_manager');
	  $domain['files'][]=array('caption'=>'Шаблоны','item'=>$drow['name'].'_files_templates');
      $domain['files'][]=array('caption'=>'Зарегистрированные изображения','item'=>$drow['name'].'_files_images');
	  $domain['files'][]=array('caption'=>'Зарегистрированные файлы','item'=>$drow['name'].'_files_files');

	  $form->data['domains'][]=$domain;

	}
	A::$DB->free();

	if(!empty($form->data['domains']))
	$form->data['domains'][0]['selected']=true;

	$this->RESULT['html']=$form->getContent();
  }

  function getEditAdminForm()
  {
    $form = new A_Form("system_admins_edit.tpl");

	$form->data=A::$DB->getRowById($_POST['id'],"_auth");

	$access=!empty($form->data['access'])?unserialize($form->data['access']):array();
	$form->data['accessall']=count($access)==0;

	$form->data['domains']=array();
	$form->data['sdomains']=array();

	$selected=false;

    A::$DB->query("SELECT * FROM _domains ORDER BY domain");
	while($drow=A::$DB->fetchRow())
	{
	  $form->data['sdomains'][$drow['name']]=$drow['domain'];

	  $sections=array();
	  A::$DB->query("SELECT name,caption,lang FROM {$drow['name']}_sections WHERE active='Y' AND (icon='Y' OR menu='Y') ORDER BY sort");
	  while($row=A::$DB->fetchRow())
	  { $row['section']=$drow['name']."_".$row['lang']."_".$row['name'];
	    $row['checked']=!empty($access[$drow['name']]) && in_array($row['section'],$access[$drow['name']]);
	    $sections[]=$row;
	  }
	  A::$DB->free();

	  $structures=array();
	  A::$DB->query("SELECT name,caption FROM {$drow['name']}_structures WHERE icon='Y' OR menu='Y' ORDER BY sort");
	  while($row=A::$DB->fetchRow())
	  { $row['structure']=$drow['name']."_structure_".$row['name'];
	    $row['checked']=!empty($access[$drow['name']]) && in_array($row['structure'],$access[$drow['name']]);
	    $structures[]=$row;
	  }
	  A::$DB->free();

	  $domain=array(
	  'domain'=>$drow['domain'],
	  'name'=>$drow['name'],
	  'sections'=>$sections,
	  'structures'=>$structures,
	  'files'=>array(),
	  'checked'=>isset($access[$drow['name']])&&empty($access[$drow['name']]));

	  $domain['files'][]=array('caption'=>'Файловый менеджер','item'=>$drow['name'].'_files_manager','checked'=>!empty($access[$drow['name']])&&in_array($drow['name'].'_files_manager',$access[$drow['name']]));
	  $domain['files'][]=array('caption'=>'Шаблоны','item'=>$drow['name'].'_files_templates','checked'=>!empty($access[$drow['name']])&&in_array($drow['name'].'_files_templates',$access[$drow['name']]));
      $domain['files'][]=array('caption'=>'Зарегистрированные изображения','item'=>$drow['name'].'_files_images','checked'=>!empty($access[$drow['name']])&&in_array($drow['name'].'_files_images',$access[$drow['name']]));
	  $domain['files'][]=array('caption'=>'Зарегистрированные файлы','item'=>$drow['name'].'_files_files','checked'=>!empty($access[$drow['name']])&&in_array($drow['name'].'_files_files',$access[$drow['name']]));

	  if(!$selected && ($domain['checked'] || !empty($access[$drow['name']])))
	  $domain['selected']=$selected=true;
	  else
	  $domain['selected']=false;

	  $form->data['domains'][]=$domain;
	}

	if(!$selected && !empty($form->data['domains']))
	$form->data['domains'][0]['selected']=true;

	A::$DB->free();

	$this->RESULT['html']=$form->getContent();
  }
}

A::$REQUEST = new SystemAdmins_Request;