<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SystemBases extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("system_bases.tpl");

	$this->AddJScript("/admin/jscripts/system_bases.js");
  }

  function Action($action)
  {
    $res=false;
    switch($action)
	{ case "add": $res=$this->Add(); break;
	  case "edit": $res=$this->Edit(); break;
	  case "del": $res=$this->Del(); break;
	  case "save": $res=$this->Save(); break;
	}
	if($res)
	A::goUrl("admin.php?mode=system&item=bases",array('page'));
  }

  function Add()
  {
    $_REQUEST['host']=trim($_REQUEST['host']);
	$_REQUEST['name']=trim($_REQUEST['name']);
	$_REQUEST['user']=trim($_REQUEST['user']);
	$_REQUEST['password']=trim($_REQUEST['password']);

	if($_REQUEST['name']==$GLOBALS['A_DBCONFIG']['name'] || A::$DB->existsRow("SELECT * FROM _bases WHERE name=?",$_REQUEST['name']))
	{ $this->errors['doublebase']=true;
	  return false;
	}

	$mysql = @new mysqli($_REQUEST['host'],$_REQUEST['user'],$_REQUEST['password'],$_REQUEST['name']);
    if(mysqli_connect_errno())
    { $this->errors['noconnect']=mysqli_connect_error();
      return false;
    }

	$dataset = new A_DataSet("_bases");
	$dataset->fields=array("host","name","user","password");
	return $dataset->Insert();
  }

  function Edit()
  {
	$_REQUEST['host']=trim($_REQUEST['host']);
	$_REQUEST['name']=trim($_REQUEST['name']);
	$_REQUEST['user']=trim($_REQUEST['user']);
	$_REQUEST['password']=trim($_REQUEST['password']);

	if($_REQUEST['name']==$GLOBALS['A_DBCONFIG']['name'] || A::$DB->existsRow("SELECT * FROM _bases WHERE name=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['name']))
	{ $this->errors['doublebase']=true;
	  return false;
	}

	$mysql = @new mysqli($_REQUEST['host'],$_REQUEST['user'],$_REQUEST['password'],$_REQUEST['name']);
    if(mysqli_connect_errno())
    { $this->errors['noconnect']=mysqli_connect_error();
      return false;
    }

   	$dataset = new A_DataSet("_bases");
	$dataset->fields=array("host","name","user","password");
	return $dataset->Update();
  }

  function Del()
  {
	$dataset = new A_DataSet("_bases");
	$sites=A::$DB->getCount("_domains","idbase=".$dataset->data['id']);
	if($sites>0)
	{ $this->errors['existssites']=true;
	  return false;
	}
	return $dataset->Delete();
  }

  function Save()
  {
	A::$DB->Update("_options",array('value'=>(integer)$_REQUEST['bdlimit']),"var='bdlimit'");
    delfile('cache/db/options.dat');

	return true;
  }

  function getBaseInfo($config)
  {
    $data=array('name'=>$config['host'].' / '.$config['name'],'tables'=>0,'size'=>0);
	$mysql = @new mysqli($config['host'],$config['user'],$config['password'],$config['name']);
	if(mysqli_connect_errno())
	return false;
	$tables=array();
	$result=$mysql->query("SHOW TABLE STATUS");
	while($row=$result->fetch_assoc())
	{ $data['tables']++;
	  $data['size']+=$row['Data_length']+$row['Index_length'];
	}
	$result->free();
	$mysql->close();
	$data['size']=sizestring($data['size']);
	return $data;
  }

  function createData()
  {
	$this->Assign("caption","Базы данных MySQL");

	$mainbase=$this->getBaseInfo($GLOBALS['A_DBCONFIG']);
	$mainbase['sites']=A::$DB->getCount("_domains","idbase=0");

	$this->Assign("mainbase",$mainbase);

    $bases=array();
	A::$DB->query("SELECT * FROM _bases ORDER BY id");
	while($brow=A::$DB->fetchRow())
	{ if($info=$this->getBaseInfo($brow))
	  $row=$info;
	  else
	  $row=array('name'=>$brow['host'].' / '.$brow['name'],'close'=>true);
	  $row['id']=$brow['id'];
	  $row['sites']=A::$DB->getCount("_domains","idbase=".$brow['id']);
	  $bases[]=$row;
	}
	A::$DB->free();

    $this->Assign("bases",$bases);
  }
}

A::$MAINFRAME = new SystemBases;