<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SystemDomains extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("system_domains.tpl");

	$this->AddJScript("/admin/jscripts/system_domains.js");
  }

  function Action($action)
  {
    @set_time_limit(0);

    $res=false;
    switch($action)
	{ case "add": $res=$this->Add(); break;
	  case "edit": $res=$this->Edit(); break;
	  case "save": $res=$this->Save(); break;
	  case "del": $res=$this->Del(); break;
      case "up": $res=$this->Up(); break;
	  case "down": $res=$this->Down(); break;
	  case "import": $res=$this->Import(); break;
	  case "delete": $res=$this->Delete(); break;
	}
	if($res)
	{ $link="admin.php?mode=system&item=domains";
	  if($res!==true) $link.="&import=$res";
	  A::goUrl($link,array('page'));
	}
  }

  function Add()
  {
	$_REQUEST['name']=substr(strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",trim($_REQUEST['name']))),0,30);
	$_REQUEST['domain']=preg_replace("/^http\:\/\//i","",trim($_REQUEST['domain']));
	$_REQUEST['domain']=preg_replace("/^www\./i","",$_REQUEST['domain']);
	$_REQUEST['domain']=mb_strtolower(preg_replace("/[^a-zA-Zа-яА-Я0-9._-]+/iu","",$_REQUEST['domain']));
	$_REQUEST['code']=trim($_REQUEST['code']);
	$_REQUEST['caption']=trim(strip_tags($_REQUEST['caption']));
	$_REQUEST['date']=time();

	$ignore=array('admin','tmp');

	if(empty($_REQUEST['name']) || in_array($_REQUEST['name'],$ignore) || A::$DB->existsRow("SELECT * FROM _domains WHERE name=?",$_REQUEST['name']))
	{ $this->errors['doubleid']=true;
	  return false;
	}
	if(empty($_REQUEST['domain']) || A::$DB->existsRow("SELECT * FROM _domains WHERE domain=?",$_REQUEST['domain']))
	{ $this->errors['doubledomain']=true;
	  return false;
	}

	$dataset = new A_DataSet("_domains");
	$dataset->fields=array("date","name","idbase","domain","caption","code");
	if($dataset->Insert())
	{ $sql=file_get_contents("system/sql-xml/domain_create.sql");
      $sql=str_replace("{domain}",$_REQUEST['name'],$sql);
      A::$DB->execSQL($sql,$_REQUEST['name']);

	  if(!file_exists("templates/".$_REQUEST['name']))
	  { mk_dir("files/".$_REQUEST['name']);
		mk_dir("files/".$_REQUEST['name']."/reg_images");
		mk_dir("files/".$_REQUEST['name']."/reg_files");
	    mk_dir("templates/".$_REQUEST['name']);
	    mk_dir("templates/".$_REQUEST['name']."/blocks");
		mk_dir("templates/".$_REQUEST['name']."/frames");
		mk_dir("templates/".$_REQUEST['name']."/mails");
		mk_dir("templates/".$_REQUEST['name']."/others");
  	    mk_dir("templates_c/".$_REQUEST['name']);
		mk_dir("templates_c/".$_REQUEST['name']."/blocks");
		mk_dir("templates_c/".$_REQUEST['name']."/frames");
		mk_dir("templates_c/".$_REQUEST['name']."/mails");
		mk_dir("templates_c/".$_REQUEST['name']."/others");
		mk_dir("cache/images/".$_REQUEST['name']);
	  }

      require_once("admin/site_import.php");

	  if(isset($_FILES['configarch']['tmp_name']) && is_file($_FILES['configarch']['tmp_name']))
	  { $_REQUEST['importmode']=3;
	    $res=SiteImport::Import($_REQUEST['name']);
	  }
	  else
	  { $_REQUEST['importmode']=2;
	    $_REQUEST['importpath']="templates/default.tar.gz";
	    $res=SiteImport::Import($_REQUEST['name']);

	    if(!empty($_REQUEST['caption']))
		{ A::$DB->Update($_REQUEST['name']."_options",array('value'=>$_REQUEST['caption']),"item='' AND var='sitename_ru'");
          A::$DB->Update($_REQUEST['name']."_options",array('value'=>$_REQUEST['caption']),"item='' AND var='sitetitle_ru'");
          A::$DB->Update($_REQUEST['name']."_options",array('value'=>'no-reply@'.$_REQUEST['domain']),"item='' AND var='mailsfrom'");
        }
	  }

	  A_Session::set('A_DOMAIN',A::$DOMAIN=$_REQUEST['name']);

	  setOption('','userep',isset($_REQUEST['userep'])?1:0);

	  if(!empty($res))
	  return $res=='ok'?true:$res;
	  else
	  return true;
	}
	return false;
  }

  function Edit()
  {
    $_REQUEST['name']=substr(strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",trim($_REQUEST['name']))),0,30);
	$_REQUEST['domain']=preg_replace("/^http\:\/\//i","",trim($_REQUEST['domain']));
	$_REQUEST['domain']=preg_replace("/^www\./i","",$_REQUEST['domain']);
	$_REQUEST['domain']=mb_strtolower(preg_replace("/[^a-zA-Zа-яА-Я0-9._-]+/iu","",$_REQUEST['domain']));
	$_REQUEST['code']=trim($_REQUEST['code']);

	$ignore=array('admin','images','tmp');

	if(empty($_REQUEST['name']) || in_array($_REQUEST['name'],$ignore) || A::$DB->existsRow("SELECT * FROM _domains WHERE name=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['name']))
	{ $this->errors['doubleid']=true;
	  return false;
	}
	if(empty($_REQUEST['domain']) || A::$DB->existsRow("SELECT * FROM _domains WHERE domain=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['domain']))
	{ $this->errors['doubledomain']=true;
	  return false;
	}

   	$dataset = new A_DataSet("_domains");
	$dataset->fields=array("name","domain","code");
	if($row=$dataset->data)
	{
	  if($_REQUEST['name']!=$row['name'])
  	  {
	    $tables=A::$DB->getTables($row['name']);
		foreach($tables as $table)
		if(preg_match("/^".$row['name']."_/i",$table,$match))
		{ $newtable=preg_replace("/^".$row['name']."/i",$_REQUEST['name'],$table);
		  A::$DB->execute("ALTER TABLE `$table` RENAME `$newtable`");
		}

		$dataset->Update();

		A::$DB->query("SELECT id,item FROM ".$_REQUEST['name']."_options");
		while($crow=A::$DB->fetchRow())
		if(preg_match("/^".$row['name']."_/i",$crow['item'],$match))
		{ $section=preg_replace("/^".$row['name']."/i",$_REQUEST['name'],$crow['item']);
		  A::$DB->execute("UPDATE ".$_REQUEST['name']."_options SET item='$section' WHERE id=".$crow['id']);
		}
		A::$DB->free();

		A::$DB->query("SELECT id,item,itemeditor FROM ".$_REQUEST['name']."_blocks");
		while($crow=A::$DB->fetchRow())
		{ if(preg_match("/^".$row['name']."_/i",$crow['item'],$match))
		  { $section=preg_replace("/^".$row['name']."/i",$_REQUEST['name'],$crow['item']);
		    A::$DB->execute("UPDATE ".$_REQUEST['name']."_blocks SET item='$section' WHERE id=".$crow['id']);
		  }
		  if(preg_match("/^".$row['name']."_/i",$crow['itemeditor'],$match))
		  { $section=preg_replace("/^".$row['name']."/i",$_REQUEST['name'],$crow['itemeditor']);
		    A::$DB->execute("UPDATE ".$_REQUEST['name']."_blocks SET itemeditor='$section' WHERE id=".$crow['id']);
		  }
		}
		A::$DB->free();

		A::$DB->query("SELECT id,item FROM ".$_REQUEST['name']."_fields");
		while($crow=A::$DB->fetchRow())
		if(preg_match("/^".$row['name']."_/i",$crow['item'],$match))
		{ $section=preg_replace("/^".$row['name']."/i",$_REQUEST['name'],$crow['item']);
		  A::$DB->execute("UPDATE ".$_REQUEST['name']."_fields SET item='$section' WHERE id=".$crow['id']);
		}
		A::$DB->free();

	    if(is_dir("files/".$row['name']) && !is_dir("files/".$_REQUEST['name']))
	    rename("files/".$row['name'],"files/".$_REQUEST['name']);
	    if(is_dir("templates/".$row['name']) && !is_dir("templates/".$_REQUEST['name']))
	    rename("templates/".$row['name'],"templates/".$_REQUEST['name']);
	    if(is_dir("templates_c/".$row['name']) && !is_dir("templates_c/".$_REQUEST['name']))
	    rename("templates_c/".$row['name'],"templates_c/".$_REQUEST['name']);
		if(is_dir("cache/images/".$row['name']) && !is_dir("cache/images/".$_REQUEST['name']))
	    rename("cache/images/".$row['name'],"cache/images/".$_REQUEST['name']);

	    replaceDir("/templates/".$row['name'],"/templates/".$_REQUEST['name'],'templates/'.$_REQUEST['name'].'/');
		delFilesByDir("templates_c/".$_REQUEST['name']);
		A_Session::unregister("A_DOMAIN");
	  }
	  else
	  $dataset->Update();

	  return true;
	}
	return false;
  }

  function Save()
  {
	$_REQUEST['id']=A::$DB->getOne("SELECT id FROM _domains WHERE domain=?",$_REQUEST['domain']);

	if(empty($_REQUEST['id']))
	return false;

   	$dataset = new A_DataSet("_domains");
	$dataset->fields=array("caption");
	if($dataset->Update())
	{ setOption('','sitename_ru',$_REQUEST['caption']);
	  return true;
	}
	else
	return false;
  }

  function Del($id=0)
  {
	if($id>0)
	$_REQUEST['id']=$id;

	$dataset = new A_DataSet("_domains");
	if($dataset->data)
	{
	  delDir("files/".$dataset->data['name']);
	  delDir("templates/".$dataset->data['name']);
	  delDir("templates_c/".$dataset->data['name']);
	  delDir("cache/images/".$dataset->data['name']);
	  delDir("cache/db/".$dataset->data['name']);

	  $tables=A::$DB->getTables($dataset->data['name']);
	  foreach($tables as $table)
      if(preg_match("/^".$dataset->data['name']."_/i",$table))
	  A::$DB->execute("DROP TABLE `$table`");

	  A_Session::unregister("A_DOMAIN");

	  $dataset->Delete();
	  return true;
	}
	return false;
  }

  function Delete()
  {
    if(isset($_REQUEST['domaincheck']))
	foreach($_REQUEST['domaincheck'] as $id)
	$this->Del($id);
	return true;
  }

  function Import()
  {
	$_REQUEST['importmode']=3;
	require_once("admin/site_import.php");

	if(isset($_REQUEST['domains']))
 	foreach($_REQUEST['domains'] as $DOMAIN)
	{ $DOMAIN=mb_strtolower(preg_replace("/[^a-zA-Z0-9]+/i","",$DOMAIN));
	  SiteImport::$eupdate=false;
	  $res=SiteImport::Import($DOMAIN);
	  if($res!='ok') return $res;
	}

	return true;
  }

  function createData()
  {
	$this->Assign("caption","Сайты");

    $domains=array();
    $pager = new A_Pager(20);
	$pager->query("SELECT * FROM _domains ORDER BY id");
    while($row=$pager->fetchRow())
	{ $row['link']="http://".$row['domain'];
	  if($row['idbase']>0)
	  { if($base=A::$DB->getRowById($row['idbase'],"_bases"))
	    $row['base']=$base['host'].' / '.$base['name'];
	  }
	  else
	  $row['base']=$GLOBALS['A_DBCONFIG']['host'].' / '.$GLOBALS['A_DBCONFIG']['name'];
	  $row['activate']=true;
	  $domains[]=$row;
	}
	$pager->free();

    $this->Assign("domains",$domains);
    $this->Assign("domains_pager",$pager);

	if(!empty($_REQUEST['import']))
	$this->Assign("debugdata",'<script type="text/javascript">alert("'.$_REQUEST['import'].'")</script>');
  }
}

A::$MAINFRAME = new SystemDomains;