<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package APanel
 */
/**************************************************************************/

class SystemUpdates extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("system_updates.tpl");
  }

  function Action($action)
  {
    @set_time_limit(0);

	$res=false;
    switch($action)
	{ case "update": $res=$this->Update(); break;
	  case "autoupdate": $res=$this->AutoUpdate(); break;
	}
	if($res)
	A::goUrl("admin.php?mode=system&item=updates".($res!==true?"&update=$res":""));
  }

  function Update()
  {
    mk_dir("files/tmp");
	clearDir("files/tmp");

	if(isset($_FILES['updatefile']['tmp_name']) && file_exists($_FILES['updatefile']['tmp_name']))
    { $path_parts=pathinfo($_FILES['updatefile']['name']);
	  $ext=preg_replace("/[^a-z0-9]+/i","",mb_strtolower($path_parts['extension']));
	  if($ext=='gz')
	  { try
	    { return $this->UpdateSystem($_FILES['updatefile']['tmp_name']);
	    }
	    catch(exception $exception)
	    { print $exception->__toString().'<br>';
		  return false;
	    }
	  }
	}
	return "err_file";
  }

  function writeable($dirIn='files/tmp/files',$dirTo='.')
  {
    if(!is_dir($dirIn)) return false;
    $result=true;
	$dir=dir($dirIn);
    while($file=$dir->read())
    { if($file!='.' && $file!='..')
	  { if(is_dir($dirIn.'/'.$file))
	    $result=$result && $this->writeable($dirIn.'/'.$file,$dirTo.'/'.$file);
		else
		$result=$result && (!is_file($dirTo.'/'.$file) || is_writeable($dirTo.'/'.$file));
      }
    }
    $dir->close();
    return $result;
  }

  function UpdateSystem($path)
  {
	if(extractArchive($path,"files/tmp"))
	{
	  $xml = loadXML("files/tmp/update.xml",true);
	  if(!$xml) return false;

	  $fupdate = empty($xml['version']) || (!empty($xml['version']) && $xml['version']>A::$OPTIONS['version']);
	  $domains=A::$DB->getCol("SELECT name FROM _domains");

	  if($fupdate)
	  {
		if(!$this->writeable())
		return "err_unpack";

		copyDir("files/tmp/files",".",true);

		if(!empty($xml['version']))
		{
		  $from=(float)preg_replace("/[0-9]{2}$/","",A::$OPTIONS['version']);
		  $to=(float)preg_replace("/[0-9]{2}$/","",$xml['version']);

		  for($v=$from;$v<$to;$v+=0.01)
		  { foreach($domains as $domain)
		    { $sqlfile=str_replace(",",".",sprintf("files/tmp/sql/domain_%.2f-%.2f.sql",$v,$v+0.01));
		      if($sql=@file_get_contents($sqlfile))
		      { $sql=str_replace("{domain}",$domain,$sql);
		        A::$DB->execSQL($sql,$domain);
		        copyfile($sqlfile,"system/sql-xml/".basename($sqlfile),true);
		      }
		    }

			$sqlfile=str_replace(",",".",sprintf("files/tmp/sql/system_%.2f-%.2f.sql",$v,$v+0.01));
		    if($sql=@file_get_contents($sqlfile))
		    A::$DB->execSQL($sql);

            $phpfile=str_replace(",",".",sprintf("files/tmp/php/update_%.2f-%.2f.php",$v,$v+0.01));
		    if(is_file($phpfile))
		    require_once($phpfile);
		  }

		  A::$DB->Update("_options",array('value'=>$xml['version']),"var='version'");
		  delfile('cache/db/options.dat');

		  A::$CACHE->resetAll();
		}

		delFilesByDir("templates_c/admin");
		delDir("files/tmp");

		return "ok" ;
	  }
	  else
	  return "err_version";
	}
	return "err_file";
  }

  function AutoUpdate()
  {
	mk_dir("files/tmp");
    clearDir("files/tmp");

    if(!empty($_REQUEST['system']))
	{ if($data=url_get_content("http://update.a-cms.ru/download.php?type=system&version=".A::$OPTIONS['version']))
	  { file_put_contents("files/tmp/update.tar.gz",$data);
	    try
	    { $res=$this->UpdateSystem("files/tmp/update.tar.gz");
	    }
	    catch(exception $exception)
	    { print $exception->__toString().'<br>';
		  return false;
	    }
		if($res!="ok")
		return $res;
		else
		return true;
	  }
	}

	if(!empty($_REQUEST['ext']))
	foreach($_REQUEST['ext'] as $file)
	if(preg_match("/^([a-z]+)_([a-z0-9_]+)$/i",$file,$matches))
	{ if($data=url_get_content("http://update.a-cms.ru/download.php?type={$matches[1]}&name={$matches[2]}"))
	  { try
	    { require_once("admin/system_extensions.php");
		  clearDir("files/tmp");
	      file_put_contents("files/tmp/{$file}.tar.gz",$data);
	      SystemExtensions::Upload("files/tmp/{$file}.tar.gz");
		  $extup=true;
		}
		catch(exception $exception)
		{ print $exception->__toString().'<br>';
		}
	  }
	}
	if(!empty($extup))
	SystemExtensions::Update();

	delDir("files/tmp");

	if(!empty($res))
	return $res;
	elseif(!empty($extup))
	return "ok";
  }

  function createData()
  {
    $this->Assign("caption","Обновление");

	if(!empty(A::$OPTIONS['autoupdate']))
	{
      if($xml = url_get_content("http://update.a-cms.ru"))
	  if($xml = loadXML($xml))
      {
		if(isset($xml['extension']['type']))
	    $xml['extension']=array($xml['extension']);

		if(!empty($xml['system']) && $xml['system']>A::$OPTIONS['version'])
	    $this->Assign("newversion",$xml['system']);

	    $types=array('module'=>'Модуль','plugin'=>'Плагин','block'=>'Блок');
	    $versions=array(
	    'module'=>A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='module'"),
	    'plugin'=>A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='plugin'"),
	    'block'=>A::$DB->getAssoc("SELECT name,version FROM _extensions WHERE type='block'"));

	    foreach($versions['module'] as $module=>$version)
	    { if($_xml=loadXML('modules/'.$module.'/sql-xml/install.xml',true))
	      { if(!empty($_xml['noupdate']))
	        unset($versions['module'][$module]);
	      }
	    }
	    foreach($versions['plugin'] as $plugin=>$version)
	    { if($_xml=loadXML('plugins/'.$plugin.'/sql-xml/install.xml',true))
	      { if(!empty($_xml['noupdate']))
	        unset($versions['plugin'][$plugin]);
	      }
	    }
	    foreach($versions['block'] as $block=>$version)
	    { if($_xml=loadXML('blocks/'.$block.'/install.xml',true))
	      { if(!empty($_xml['noupdate']))
	        unset($versions['block'][$block]);
	      }
	    }

	    $extensions=array();
	    if(!empty($xml['extension']))
	    foreach($xml['extension'] as $ext)
	    if(isset($versions[$ext['type']][$ext['name']]) && $ext['version']>$versions[$ext['type']][$ext['name']])
	    { $ext['file']=$ext['type'].'_'.$ext['name'];
	      $ext['name']=A::$DB->getOne("SELECT caption FROM _extensions WHERE type=? AND name=?",array($ext['type'],$ext['name']));
		  $ext['type']=isset($types[$ext['type']])?$types[$ext['type']]:"?";
	      $extensions[]=$ext;

	    }
	    $this->Assign("extensions",$extensions);

	    if($xml['system']<=A::$OPTIONS['version'] && empty($extensions))
	    A_Session::set("isupdate",false);
	    else
	    A_Session::set("isupdate",true);
	  }
	}
  }
}

A::$MAINFRAME = new SystemUpdates;