DROP TABLE IF EXISTS `_auth`;
CREATE TABLE `_auth` (
  `id` int(11) NOT NULL auto_increment,
  `date` int(11) NOT NULL default '0',
  `dauth` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `login` varchar(20) NOT NULL default '',
  `password` varchar(50) NOT NULL default '',
  `email` varchar(50) NOT NULL default '',
  `access` blob default NULL,
  `expert` enum('Y','N') NOT NULL default 'Y',
  `active` enum('Y','N') NOT NULL default 'Y',
  `authcode` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `login` (`login`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `_bases`;
CREATE TABLE `_bases` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '0',
  `host` varchar(50) NOT NULL default '',
  `user` varchar(50) NOT NULL default '',
  `password` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `_domains`;
CREATE TABLE `_domains` (
  `id` int(11) NOT NULL auto_increment,
  `date` int(11) NOT NULL default '0',
  `idbase` int(11) NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `domain` varchar(100) NOT NULL default '',
  `caption` varchar(100) NOT NULL default '',
  `code` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `idbase` (`idbase`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `_extensions`;
CREATE TABLE `_extensions` (
  `id` int(11) NOT NULL auto_increment,
  `type` enum('module','plugin','block') NOT NULL default 'module',
  `name` varchar(50) NOT NULL default '',
  `caption` varchar(100) NOT NULL default '',
  `multiple` enum('Y','N') NOT NULL default 'Y',
  `useauth` enum('Y','N') NOT NULL default 'N',
  `usecron` enum('Y','N') NOT NULL default 'N',
  `owner` varchar(100) NOT NULL default '',
  `version` decimal(5,4) NOT NULL default '2.00',
  `system` decimal(5,4) NOT NULL default '2.00',
  `sort` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `type_name` (`type`,`name`),
  KEY `type` (`type`),
  KEY `useauth` (`useauth`),
  KEY `sort` (`sort`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `_options`;
CREATE TABLE `_options` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `var` varchar(50) NOT NULL default '',
  `value` varchar(50) NOT NULL default '',
  `type` varchar(10) NOT NULL default 'string',
  PRIMARY KEY  (`id`),
  KEY `var` (`var`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `_options` VALUES (1,'Версия системы','version','2.00.00','string');
INSERT INTO `_options` VALUES (2,'Проверять наличие обновлений','autoupdate','1','bool');
INSERT INTO `_options` VALUES (3,'Режим отладки','debugmode','0','int');
INSERT INTO `_options` VALUES (4,'Защищенный режим Smarty','smartysecurity','1','int');
INSERT INTO `_options` VALUES (5,'Кэширование','caching','0','int');
INSERT INTO `_options` VALUES (6,'Лимит сайтов на одну БД','bdlimit','30','int');
INSERT INTO `_options` VALUES (7,'Использовать SMTP сервер','smtp_use','0','bool');
INSERT INTO `_options` VALUES (8,'SMTP Хост','smtp_host','localhost','string');
INSERT INTO `_options` VALUES (9,'SMTP Порт','smtp_port','25','int');
INSERT INTO `_options` VALUES (10,'SMTP Авторизация','smtp_auth','0','bool');
INSERT INTO `_options` VALUES (11,'SMTP Логин','smtp_login','','string');
INSERT INTO `_options` VALUES (12,'SMTP Пароль','smtp_password','','string');
