<?php
/** \file request.php
 * Инициализация окружения и начальная маршрутизация серверной стороны AJAX.
 */
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package AFramework
 */
/**************************************************************************/

$_GET['mode']=preg_replace("/[^a-zA-Z0-9_]+/i","",$_GET['mode']);
$_GET['item']=preg_replace("/[^a-zA-Z0-9_]+/i","",$_GET['item']);

if(empty($_GET['mode']))
exit();

switch($_GET['mode'])
{ case "system":
  case "site":
  case "files":
  case "sections":
  case "structures":
  case "block":
  case "object":
	define("A_MODE",1);
	break;
  case "front":
	define("A_MODE",0);
	break;
  default: exit();
}

require_once("system/framework/ini.php");
require_once("system/framework/request.php");

if(A_MODE==1 && !A::$AUTH->isLogin())
exit();

switch($_GET['mode'])
{ case "system":
    if(A::$AUTH->isSuperAdmin())
	$A_MAINFILE="admin/".$_GET['mode']."_".$_GET['item']."_request.php";
	break;

  case "site":
	if((A::$AUTH->isAdmin() || A::$AUTH->isLogin()) && !empty(A::$DOMAIN))
	$A_MAINFILE="admin/".$_GET['mode']."_".$_GET['item']."_request.php";
	break;

  case "files":
    if(!empty(A::$DOMAIN) && (A::$AUTH->isAdmin() || in_array(DOMAIN.'_files_'.$_GET['item'],A::$AUTH->data['access'][DOMAIN])))
	$A_MAINFILE="admin/".$_GET['mode']."_".$_GET['item']."_request.php";
	break;

  case "sections":
	if(A::$AUTH->isAdmin() || in_array($_GET['item'],A::$AUTH->data['access'][DOMAIN]))
	{ $section=parseSection($_GET['item']);
	  if($row=A::$DB->getRow("SELECT * FROM ".$section['domain']."_sections WHERE name='".$section['name']."' AND (lang='".$section['lang']."' OR lang='all')"))
      { $A_MAINFILE="modules/".$row['module']."/admin/request.php";
	    define("MODULE",$row['module']);
		define("SECTION",$_GET['item']);
		define("SECTION_ID",$row['id']);
		define("SECTION_NAME",$row['caption']);
	    define("LANG",$section['lang']);
	    define("SNAME",$section['name']);
		A::$REGFILES=SECTION;
	  }
    }
	break;

  case "structures":
	if(A::$AUTH->isAdmin() || in_array($_GET['item'],A::$AUTH->data['access'][DOMAIN]))
	{ $structure=parseStructure($_GET['item']);
	  if($row=A::$DB->getRow("SELECT * FROM ".$structure['domain']."_structures WHERE name='".$structure['name']."'"))
      { $A_MAINFILE="plugins/".$row['plugin']."/admin/request.php";
	    define("PLUGIN",$row['plugin']);
	    define("STRUCTURE",empty($row['source'])?$_GET['item']:$row['source']);
	    define("SNAME",$structure['name']);
	  }
    }
	break;

  case "block":
    if(A::$AUTH->isLogin())
	$A_MAINFILE="blocks/".$_GET['item']."/request.php";
	break;

  case "object":
    if(!empty($_REQUEST['section']))
	{ $_REQUEST['mode']='sections';
	  if(A::$AUTH->isAdmin() || in_array($_REQUEST['section'],A::$AUTH->data['access'][DOMAIN]))
	  { $section=parseSection($_REQUEST['section']);
	  	if($row=A::$DB->getRow("SELECT * FROM ".$section['domain']."_sections WHERE name='".$section['name']."' AND (lang='".$section['lang']."' OR lang='all')"))
        { define("MODULE",$row['module']);
		  define("SECTION",$_REQUEST['section']);
		  define("SECTION_ID",$row['id']);
		  define("SECTION_NAME",$row['caption']);
		  define("LANG",$section['lang']);
	      define("SNAME",$section['name']);
		  A::$REGFILES=SECTION;
	    }
	  }
	}

    if(!empty($_REQUEST['structure']))
	{ $_REQUEST['mode']='structures';
	  if(A::$AUTH->isAdmin() || in_array($_REQUEST['structure'],A::$AUTH->data['access'][DOMAIN]))
	  { $structure=parseStructure($_REQUEST['structure']);
	    if($row=A::$DB->getRow("SELECT * FROM ".$structure['domain']."_structures WHERE name='".$structure['name']."'"))
        { define("PLUGIN",$row['plugin']);
	      define("STRUCTURE",empty($row['source'])?$_REQUEST['structure']:$row['source']);
	      define("SNAME",$structure['name']);
	    }
	  }
	}
	$A_MAINFILE="system/objcomp/".$_GET['item']."_request.php";
	break;

  case "front":
	$section=parseSection($_GET['item']);
	if($section['lang']=='structure')
	{ $structure=parseStructure($_GET['item']);
	  if($row=A::$DB->getRow("SELECT * FROM ".$structure['domain']."_structures WHERE name='".$structure['name']."'"))
      { $A_MAINFILE="plugins/".$row['plugin']."/request.php";
	    define("PLUGIN",$row['plugin']);
	    define("STRUCTURE",empty($row['source'])?$_GET['item']:$row['source']);
	    define("SNAME",$structure['name']);
	  }
	}
	elseif($row=A::$DB->getRow("SELECT * FROM ".$section['domain']."_sections WHERE name='".$section['name']."' AND (lang='".$section['lang']."' OR lang='all')"))
    { $A_MAINFILE="modules/".$row['module']."/request.php";
	  define("MODULE",$row['module']);
	  define("SECTION",$_GET['item']);
	  define("SECTION_ID",$row['id']);
	  define("LANG",isset($_REQUEST['lang'])?$_REQUEST['lang']:($section['lang']!='all'?$section['lang']:DEFAULTLANG));
	  define("SECTION_NAME",$row['caption_'.LANG]);
	  define("SNAME",$section['name']);
	  A::$REGFILES=SECTION;
	}

	break;

  default: return;
}

define("MODE",!empty($_REQUEST['mode'])?$_REQUEST['mode']:$_GET['mode']);
define("ITEM",!empty($_REQUEST['item'])?$_REQUEST['item']:$_GET['item']);

if(!defined("LANG") && isset(A::$LANGUAGES))
define("LANG",preg_replace("/[^a-zA-Z0-9]+/i","",A_Session::get("A_LANG",DEFAULTLANG)));

if(defined('LANG'))
A::$LANG=LANG;

if(defined('SECTION'))
A::$SECTION=SECTION;

if(defined('SECTION_ID'))
A::$SECTION_ID=SECTION_ID;

if(defined('STRUCTURE'))
A::$SECTION=STRUCTURE;

foreach(A::$EXTENSIONS as $extrow)
if(is_file($ifile=$extrow['type']."s/".$extrow['name']."/include.php"))
require_once($ifile);

$item=defined('SECTION')?SECTION:(defined('STRUCTURE')?STRUCTURE:'');
if(!empty($item))
{ A::$DB->query("SELECT var,value FROM ".DOMAIN."_options WHERE item='$item'");
  while($row=A::$DB->fetchRow())
  A::$OPTIONS[$row['var']]=$row['value'];
  A::$DB->free();
}

if(isset($A_MAINFILE) && is_file($A_MAINFILE))
{ try
  { require_once($A_MAINFILE);

    if(A::$REQUEST && !empty($_GET['action']))
    switch(A_MODE)
    { case 0:
        A::$REQUEST->Action($_GET['action']);
	    break;
      case 1:
	    if(!empty($_GET['authcode']) && $_GET['authcode']==A::$AUTH->authcode)
        { A::$OBSERVER->Event('requestAction',$_GET['action']);
	      A::$REQUEST->Action($_GET['action']);
	    }
        break;
    }
  }
  catch(exception $exception)
  { if(A_MODE==1 || !empty(A::$OPTIONS['debugmode']))
    print $exception->__toString().'<br>';
  }
}