<?php

/** \file system/framework/ini.php
 * Инициализация.
 */
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package AFramework
 */
/**************************************************************************/

setlocale(LC_COLLATE, 'ru_RU.UTF8');
setlocale(LC_CTYPE, 'ru_RU.UTF8');
setlocale(LC_TIME, 'ru_RU.UTF8');

/**
 * Текущее время.
 */

function timeMeasure()
{ list($msec, $sec) = explode(chr(32), microtime());
  return ($sec+$msec);
}

/**
 * Время начала работы скрипта.
 */

define('TIMESTART', timeMeasure());

ini_set("register_globals",0);
ini_set("magic_quotes_gpc",0);
ini_set("mbstring.internal_encoding","utf-8");
ini_set("mbstring.http_input","auto");
ini_set("mbstring.func_overload",2);
ini_set("include_path","system/pear/".PATH_SEPARATOR.ini_get("include_path"));

/**
 * Значение для режима на сайте.
 */

define("A_MODE_FRONT",0);

/**
 * Значение для режима в панели управления.
 */

define("A_MODE_ADMIN",1);

header('Content-type: text/html; charset=utf-8');
header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");

require_once("system/framework/db.php");
require_once("system/framework/auth.php");
require_once("system/framework/session.php");
require_once("system/framework/functions.php");
require_once("system/framework/observer.php");
require_once("system/framework/cache.php");
require_once("system/framework/navigation.php");

require_once("config.php");

A_Session::start();

function __autoload($class)
{ switch($class)
  { case 'Smarty': require_once("system/smarty/Smarty.class.php"); break;
    case 'A_MainFrame': require_once("system/framework/main.php"); break;
    case 'A_DataSet': require_once("system/framework/dataset.php"); break;
    case 'A_Pager': require_once("system/framework/pager.php"); break;
    case 'A_Mail': require_once("system/framework/mail.php"); break;
	case 'A_Form': require_once("system/framework/form.php"); break;
	case 'A_Frame': require_once("system/framework/frame.php"); break;
	case 'A_Block': require_once("system/framework/block.php"); break;
	case 'A_Grid': require_once("system/framework/grid.php"); break;
	case 'A_Statistic': require_once("system/framework/statistic.php"); break;
	case 'A_SearchEngine': require_once("system/framework/search.php"); break;
	case 'A_ExcelReader': require_once("system/framework/formats.php"); break;
	case 'A_CSVReader': require_once("system/framework/formats.php"); break;
    case 'A_CategoriesTree': require_once("system/objcomp/categoriestree.php"); break;
	case 'A_CommentsEditor': require_once("system/objcomp/commeditor.php"); break;
	case 'A_FieldsEditor': require_once("system/objcomp/fieldseditor.php"); break;
	case 'A_OptionsBox': require_once("system/objcomp/optionsbox.php"); break;
	case 'A_FileAdmin': require_once("system/objcomp/fileadmin.php"); break;
	case 'A_Files': require_once("system/objcomp/files.php"); break;
	case 'A_Images': require_once("system/objcomp/images.php"); break;
  }
}

/**
 * Инициализация и реестр окружения.
 */

class A
{

/**
 * Объект для работы с БД.
 */

  static $DB;

/**
 * Объект авторизации.
 */

  static $AUTH;

/**
 * Объект системы кэширования.
 */

  static $CACHE;

/**
 * Объект системы событий.
 */

  static $OBSERVER;

/**
 * Массив опций текущего раздела/дополнения.
 */

  static $OPTIONS;

/**
 * Массив используемых расширений на сайте (модули и плагины).
 */

  static $EXTENSIONS;

/**
 * Рабочий протокол (http или https).
 */

  static $PROTOCOL;

/**
 * Идентификатор сайта.
 */

  static $DOMAIN;

/**
 * Домен сайта.
 */

  static $DOMAINNAME;

/**
 * Языковые версии.
 */

  static $LANGUAGES;

/**
 * Языковая версия по умолчанию.
 */

  static $DEFAULTLANG;

/**
 * Текущая языковая версия.
 */

  static $LANG;

/**
 * Полный строковой идентификатор раздела для регистрируемых изображений/файлов.
 */

  static $REGFILES;

/**
 * Полный строковой идентификатор текущего раздела.
 */

  static $SECTION;

/**
 * Числовой идентификатор текущего раздела.
 */

  static $SECTION_ID;

/**
 * Полный строковой идентификатор текущего дополнения.
 */

  static $STRUCTURE;

/**
 * Объект текущего модуля.
 */

  static $MAINFRAME;

/**
 * Массив элементов в пути URL.
 */

  static $URIPARAMS;

/**
 * Объект серверной части AJAX.
 */

  static $REQUEST;

/**
 * Массив значений основных переменных окружения системы.
 */

  static $SYSTEM;

/**
 * Массив с данными скачиваемого файла.
 */

  static $FILE;

/**
 * Инициализация.
 */

  function ini()
  {
    A::$PROTOCOL=getenv('HTTPS')=='on'?'https':'http';
	A::$DB=A_DB::getInstance();
	if($data=@file_get_contents('cache/db/options.dat'))
	A::$OPTIONS=unserialize($data);
	else
	{ A::$OPTIONS=A::$DB->getAssoc("SELECT var,value FROM _options");
	  file_put_contents('cache/db/options.dat',serialize(A::$OPTIONS),LOCK_EX);
	}
	A::$CACHE=A_Cache::getInstance();
	A::$AUTH=A_AUTH::getInstance();
	A::$OBSERVER=A_Observer::getInstance();

	ini_set("error_reporting",A::$OPTIONS['debugmode']?E_ALL:0);

	define('HOSTNAME',$HTTP_HOST=idn_decode(getenv('HTTP_HOST')));
	$HTTP_HOST=preg_replace("/^www\./i","",$HTTP_HOST);
	$HTTP_HOST=preg_replace("/:[0-9]+$/i","",$HTTP_HOST);

	if(A_MODE==A_MODE_FRONT)
    {
	  if(!empty($GLOBALS['A_VMOBILE']['domain']) && !empty($GLOBALS['A_VMOBILE']['subdomain']) && $GLOBALS['A_VMOBILE']['subdomain']==$HTTP_HOST)
      { $HTTP_HOST=$GLOBALS['A_VMOBILE']['domain'];
        $vmobile=true;
      }
      else
      $vmobile=false;

	  if($drow=A::$DB->getRow("SELECT name,domain,code FROM _domains WHERE domain=?",$HTTP_HOST))
      {
	    A::$DOMAIN=$drow['name'];
	    define("DOMAIN",A::$DOMAIN);
	    define("DOMAINNAME",A::$DOMAINNAME=$drow['domain']);
	    define('DOMAINCODE',$drow['code']);
	  }
      else
      { if(preg_match("/\.([a-zа-я0-9._-]+\.[a-zа-я0-9]+)$/iu",$HTTP_HOST,$matches))
		A::goUrl("http://{$matches[1]}",null,true);
        else
        A::goUrl("/admin.php");
	    exit();
	  }

	  if($vmobile && !empty($GLOBALS['A_VMOBILE']['dir']))
	  { if(!is_dir($dir="templates/".$GLOBALS['A_VMOBILE']['dir']))
	    mkdir($dir);
		define("SMARTY_TEMPLATES",$dir);
		if(!is_dir($dir="templates_c/".$GLOBALS['A_VMOBILE']['dir']))
	    { mkdir($dir);
	      mkdir($dir.'/blocks');
	      mkdir($dir.'/frames');
	      mkdir($dir.'/mails');
	      mkdir($dir.'/others');
	    }
	    define("SMARTY_COMPILE",$dir);
	  }
	  else
	  { define("SMARTY_TEMPLATES","templates/".DOMAIN);
	    define("SMARTY_COMPILE","templates_c/".DOMAIN);
	  }
	}
    else
	{
	  require_once("system/framework/html.php");

	  A::$DOMAIN=preg_replace("/[^a-zA-Z0-9]+/i","",A_Session::get('A_DOMAIN',''));
	  if(empty(A::$DOMAIN))
      { if($drow=A::$DB->getRow("SELECT name,domain,code FROM _domains WHERE domain=?",$HTTP_HOST))
	    A_Session::set('A_DOMAIN',A::$DOMAIN=$drow['name']=$drow['name']);
	    elseif($drow=A::$DB->getRow("SELECT name,domain,code FROM _domains ORDER BY id LIMIT 0,1"))
	    A_Session::set('A_DOMAIN',A::$DOMAIN=$drow['name']);
      }

      if(empty($drow) && !empty(A::$DOMAIN))
	  $drow=A::$DB->getRow("SELECT domain,code FROM _domains WHERE name=?",A::$DOMAIN);

      define("DOMAIN",A::$DOMAIN);

	  if(!empty($drow))
	  { define('DOMAINNAME',A::$DOMAINNAME=$drow['domain']);
	    define('DOMAINCODE',$drow['code']);
	  }

      define("SMARTY_TEMPLATES","templates/admin");
	  define("SMARTY_COMPILE","templates_c/admin");
	}

	if(!empty(A::$DOMAIN))
    {
	  A::$DB->query("SELECT var,value,options,type FROM ".A::$DOMAIN."_options WHERE item=''");
	  while($row=A::$DB->fetchRow())
	  A::$OPTIONS[$row['var']]=$row['type']=='text'?$row['options']:$row['value'];
	  A::$DB->free();


      A::$LANGUAGES=A::$DB->getAssoc("SELECT name,caption FROM ".DOMAIN."_languages ORDER BY sort");
      define("DEFAULTLANG",A::$DEFAULTLANG=count(A::$LANGUAGES)>0?key(A::$LANGUAGES):"");

      if(A_MODE==A_MODE_ADMIN)
      { A::$LANG=preg_replace("/[^a-zA-Z0-9]+/i","",A_Session::get('A_LANG',''));
        if(empty(A::$LANG))
        { A_Session::set("A_LANG",DEFAULTLANG);
          A::$LANG=DEFAULTLANG;
        }
      }

      define('ACTIVATE',true);

	  A::$EXTENSIONS=array();
	  $modules=A::$DB->getCol("SELECT DISTINCT module FROM ".DOMAIN."_sections ORDER BY sort");
	  foreach($modules as $module)
	  A::$EXTENSIONS[]=array('type'=>'module','name'=>$module);
	  $plugins=A::$DB->getCol("SELECT DISTINCT plugin FROM ".DOMAIN."_structures ORDER BY sort");
	  foreach($plugins as $plugin)
	  A::$EXTENSIONS[]=array('type'=>'plugin','name'=>$plugin);
	  $plugins=A::$DB->getCol("SELECT name FROM _extensions WHERE type='plugin' AND useauth='Y'");
	  foreach($plugins as $plugin)
	  A::$EXTENSIONS[]=array('type'=>'plugin','name'=>$plugin);
    }
    else
    A::$EXTENSIONS=array();
  }

/**
 * Возвращает массив значений основных переменных окружения системы.
 *
 * @return array Массив значений основных переменных окружения системы.
 */

  function getSystem()
  {
    if(!self::$SYSTEM)
	{ self::$SYSTEM=array();
	  if(defined('MODE'))
      self::$SYSTEM['mode']=MODE;
	  if(defined('ITEM'))
      self::$SYSTEM['item']=ITEM;
	  if(defined('DOMAIN'))
      self::$SYSTEM['domain']=DOMAIN;
      if(defined('MODULE'))
      self::$SYSTEM['module']=MODULE;
	  if(defined('SECTION'))
      { self::$SYSTEM['section']=SECTION;
	    self::$SYSTEM['sectionlink']=getSectionLink(SECTION);
	  }
	  if(defined('STRUCTURE'))
      { self::$SYSTEM['structure']=STRUCTURE;
        if(defined('PLUGIN'))
        self::$SYSTEM['plugin']=PLUGIN;
      }
	  if(defined('LANG'))
      self::$SYSTEM['lang']=LANG;
	  if(defined('SNAME'))
      { self::$SYSTEM['sname']=SNAME;
	    self::$SYSTEM['mainpage']=SNAME==A::$OPTIONS['mainsection'] && count(A::$URIPARAMS)==0;
	  }
	  if(A::$AUTH)
	  self::$SYSTEM['authcode']=A::$AUTH->authcode;
	  if(A::$MAINFRAME)
	  self::$SYSTEM['page']=A::$MAINFRAME->page;
	  self::$SYSTEM['curlink']=getenv('REQUEST_URI');
      self::$SYSTEM['prevlink']=A_Session::get("A_PREVURL",getenv('REQUEST_URI'));
      self::$SYSTEM['tpldir']='/'.SMARTY_TEMPLATES;
      self::$SYSTEM['imgdir']='/'.SMARTY_TEMPLATES.'/images';
      self::$SYSTEM['ie6']=!empty($_SERVER['HTTP_USER_AGENT'])&&stripos($_SERVER['HTTP_USER_AGENT'],'msie 6')!==false;
      self::$SYSTEM=A::$OBSERVER->Modifier('system_prepareValues','',self::$SYSTEM);
	}
	return self::$SYSTEM;
  }

/**
 * Страница не найдена.
 */

  function NotFound()
  {
    @header("HTTP/1.1 404 Not Found");
	if(A_MODE==A_MODE_FRONT && A::$OPTIONS['404gomain'])
	@header("Location: /");
	if(A::$MAINFRAME && is_file('templates/'.A::$DOMAIN.'/404.tpl'))
	{ A::$MAINFRAME->template='404.tpl';
	  A::$MAINFRAME->_display();
	}
	exit();
  }

/**
 * Перенаправление.
 *
 * @param string $url URL.
 * @param array $params Список GET параметров, которые необходимо добавить к URL с текущими значениями $_GET и $_POST.
 * @param boolean $moved=false С добавлением заголовка 301 Moved Permanently.
 */

  function goUrl($url,$params=null,$moved=false)
  {
    if(!empty($params))
	{ foreach($params as $i=>$value)
	  if(!empty($_POST[$value]))
	  { if(is_array($_POST[$value]))
	    { $params[$i]=array();
		  foreach($_POST[$value] as $val)
		  $params[$i][]="{$value}[]=$val";
		  $params[$i]=implode("&",$params[$i]);
        }
        else
		$params[$i]="$value={$_POST[$value]}";
	  }
	  elseif(!isset($_POST[$value]) && !empty($_GET[$value]))
	  { if(is_array($_GET[$value]))
	    { $params[$i]=array();
		  foreach($_GET[$value] as $val)
		  $params[$i][]="{$value}[]=$val";
		  $params[$i]=implode("&",$params[$i]);
        }
        else
	    $params[$i]="$value={$_GET[$value]}";
	  }
	  else
	  unset($params[$i]);
	  if(!empty($params))
	  { $purl=parse_url($url);
	    if(!empty($purl['query']))
	    $url.='&'.implode('&',$params);
	    else
	    $url.='?'.implode('&',$params);
	  }
	}
	if($moved)
	@header("HTTP/1.1 301 Moved Permanently");
	elseif(preg_match("/[а-яА-Я]+/iu",$url) && strpos(getenv('HTTP_USER_AGENT'),"MSIE")!==false && mb_strpos($url,'http://')!==0 && mb_strpos(urldecode(getenv('REQUEST_URI')),"//")!==0)
	$url="http://".HOSTNAME."/".$url;
    @header("Location: $url");
	exit();
  }

/**
 * Перенаправление на предыдущую страницу.
 */

  function goPrevUrl()
  {
	$prev=A_Session::get("A_PREVURL","/");
	if(A_MODE==A_MODE_FRONT && strpos($prev,'admin.php')!==false)
	return;
	elseif(A_MODE==A_MODE_ADMIN && strpos($prev,'admin.php')===false)
	return;
	@header("Location: {$prev}");
	exit();
  }
}

A::ini();