<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package AComponents
 */
/**************************************************************************/

/**
 * Серверная сторона AJAX для компонента "редактор дополнительных полей".
 */

class A_FieldsEditorRequest extends A_Request
{
/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    switch($action)
	{ case "getaddfieldform": $this->getAddForm(); break;
	  case "geteditfieldform": $this->getEditForm(); break;
	  case "setsort": $this->setSort(); break;
	}
  }

/**
 * Обработчик действия: Отдает форму добавления поля.
 */

  function getAddForm()
  {
    $item=MODE=='sections'?SECTION:STRUCTURE;

    $form = new A_Form("objcomp_fieldseditor_add.tpl");
	$form->data['vars']=array();

	A::$DB->query("SELECT * FROM ".DOMAIN."_structures ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $_item=DOMAIN."_structure_".$row['name'];
	  if(function_exists($row['plugin'].'_loadlist') && $_item!=$item)
      $form->data['vars'][$_item]=$row['caption'];
	}
	A::$DB->free();

	A::$DB->query("SELECT * FROM ".DOMAIN."_sections ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $_item=DOMAIN."_".$row['lang']."_".$row['name'];
	  if(function_exists($row['module'].'_loadlist') && $_item!=$item)
      $form->data['vars'][$_item]=$row['caption'];
	}
	A::$DB->free();

	$form->data['usefill']=$_POST['usefill'];
	$form->data['usesearch']=$_POST['usesearch'];
	$form->data['usenofront']=$_POST['usenofront'];

	$form->data['languages']=array();
	if(LANG=="all")
	{ foreach(A::$LANGUAGES as $key=>$name)
	  $form->data['languages'][]=array("name"=>"name_".$key,"caption"=>$name);
	}
	else
	$form->data['languages'][]=array("name"=>"name_".LANG);

	$this->RESULT['html']=$form->getContent();
  }

/**
 * Обработчик действия: Отдает форму редактирования поля.
 */

  function getEditForm()
  {
    $item=MODE=='sections'?SECTION:STRUCTURE;

    $form = new A_Form("objcomp_fieldseditor_edit.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],DOMAIN."_fields");
	$form->data['vars']=array();

	A::$DB->query("SELECT * FROM ".DOMAIN."_structures ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $_item=DOMAIN."_structure_".$row['name'];
	  if(function_exists($row['plugin'].'_loadlist') && $_item!=$item)
      $form->data['vars'][$_item]=$row['caption'];
	}
	A::$DB->free();

	A::$DB->query("SELECT * FROM ".DOMAIN."_sections ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $_item=DOMAIN."_".$row['lang']."_".$row['name'];
	  if(function_exists($row['module'].'_loadlist') && $_item!=$item)
      $form->data['vars'][$_item]=$row['caption'];
	}
	A::$DB->free();

	$form->data['usefill']=$_POST['usefill'];
	$form->data['usesearch']=$_POST['usesearch'];
	$form->data['usenofront']=$_POST['usenofront'];

	$form->data['languages']=array();
	if(LANG=="all")
	{ foreach(A::$LANGUAGES as $key=>$name)
	  $form->data['languages'][]=array("name"=>"name_".$key,"caption"=>$name,"text"=>$form->data["name_".$key]);
	}
	else
	$form->data['languages'][]=array("name"=>"name_".LANG,"text"=>$form->data["name_".LANG]);

	$this->RESULT['html']=$form->getContent();
  }

  function setSort()
  {
    $sort=!empty($_POST['sort'])?explode(",",$_POST['sort']):array();
	$i=1;
	foreach($sort as $id)
	A::$DB->Update(DOMAIN."_fields",array('sort'=>$i++),"id=".(integer)$id);
  }
}

A::$REQUEST = new A_FieldsEditorRequest;